
;*******************************************************************************	
;uint8_t bcd_to_decimal(uint8_t number)
;*******************************************************************************	
	
bcd_to_decimal:	
	MOVWF	number
	MOVLW	0xF		;return((number >> 4) * 10 + (number & 0x0F));
	ANDWF	number, W
	MOVWF	0x74		;(number & 0x0F)
	MOVLW	0xA
	MOVWF	__pcstackCOMMON
	MOVLW	0x4
AAC:	
	LSRF	number, F
	DECFSZ	WREG, F	
	GOTO	AAC
	MOVF	number, W	; Wert(number >> 4)
	CALL	__bmul
	ADDWF	0x74, W
	RETURN
	
;*******************************************************************************		
;	convert decimal to BCD function
;	uint8_t decimal_to_bcd(uint8_t number)
;
;	return(((number / 10) << 4) + (number % 10));
;*******************************************************************************
	
decimal_to_bcd:
	
	MOVWF	number        
	MOVLW	10
	MOVWF	__pcstackCOMMON	;10
	MOVLW	0x0
	MOVWF	n
	MOVF	number, W
	MOVLB	0x0
	MOVWF	__pcstackBANK0
	CLRF	al
	MOVF	__pcstackBANK0, W
	MOVWF	dividend
	MOVF	al, W
	MOVWF	LCD_Char
	CALL	__awmod
	MOVF	__pcstackCOMMON, W	;10 in W
	MOVLB	0x0
	MOVWF	x
	MOVF	n, W
	MOVWF	0x5E
	MOVLW	0xA
	MOVWF	__pcstackCOMMON
	MOVLW	0x0
	MOVWF	n
	MOVF	number, W
	MOVWF	0x5F
	CLRF	0x60
	MOVF	0x5F, W
	MOVWF	dividend
	MOVF	0x60, W
	MOVWF	LCD_Char
	CALL	__awdiv
	MOVF	__pcstackCOMMON, W
	MOVLB	0x0
	MOVWF	0x61
	MOVLW	0x3
A69A:
	LSLF	0x61, F
	ADDLW	0xFF
	BTFSS	STATUS, 0x2
	GOTO	A69A
	LSLF	0x61, W
	ADDWF	x, W
	RETURN

;*******************************************************************************	
;         // make editing parameter blinks function
;         void blink()
; while( j < 100 && (button1 || i >= 5) && button2 && (button3 || i < 5) )
;*******************************************************************************
	
blink:
	CLRF n			; uint8_t j = 0;
AD96:
	MOVLW	100		; wenn n kleiner 100 ist C=0
	SUBWF	n, W
	BTFSC	STATUS, 0x0
	RETURN
	
	MOVLB	0x0
	BTFSC	PORTB, 0x1	; wenn button1 bettigt ist RB1=0
	GOTO	ADA1		; RB1=1? dann zu button2
	MOVLW	0x5
	SUBWF	i, W
	BTFSS	STATUS, 0x0
	RETURN
	
ADA1:	
	BTFSS	PORTB, 0x2
	RETURN
		
	BTFSC	PORTB, 0x3
	GOTO	ADA9
	MOVLW	0x5
	SUBWF	i, W
	BTFSC	STATUS, 0x0
	RETURN
	
	GOTO	AD96
ADA9:	
	MOVLW	0x1	;j++;
	ADDWF	n, F
	Call	Wait    ;__delay_ms(5);
	GOTO	AD96
	
;*******************************************************************************	
;         void RTC_read()    // read current time & date from RTC chip
;*******************************************************************************
RTC_read:
           	
	CALL	I2C_Start	; I2C_Start() start I2C		
	MOVLW	0xD0	; I2C_Write(0xD0);  RTC chip address
	CALL	I2C_Write
	MOVLW	0x0	; I2C_Write(0); send register address
	CALL	I2C_Write
	CALL	0x52D	; I2C_Repeated_Start(); restart I2C
	MOVLW	0xD1	; I2C_Write(0xD1); initialize data read
	CALL	I2C_Write
	MOVLW	0x1	; second = I2C_Read(1); read seconds from register 0
	CALL	I2C_Read
	MOVWF	LCD_Char
	MOVF	LCD_Char, W
	MOVLB	0x0
	MOVWF	second
	MOVLW	0x1	; minute = I2C_Read(1); read minutes from register 1
	CALL	I2C_Read
	MOVWF	LCD_Char
	MOVF	LCD_Char, W
	MOVLB	0x0
	MOVWF	minute
	MOVLW	0x1	; hour   = I2C_Read(1); read hour from register 2
	CALL	I2C_Read
	MOVWF	LCD_Char
	MOVF	LCD_Char, W
	MOVLB	0x0
	MOVWF	hour
	MOVLW	0x1	 ; w_day  = I2C_Read(1); read day of the week from register 3
	CALL	I2C_Read
	MOVWF	LCD_Char
	MOVF	LCD_Char, W
	MOVLB	0x0
	MOVWF	w_day
	MOVLW	0x1	; m_day  = I2C_Read(1); read date from register 4
	CALL	I2C_Read
	MOVWF	LCD_Char
	MOVF	LCD_Char, W
	MOVLB	0x0
	MOVWF	m_day
	MOVLW	0x1	; month  = I2C_Read(1); read month from register 5
	CALL	I2C_Read
	MOVWF	LCD_Char
	MOVF	LCD_Char, W
	MOVLB	0x0
	MOVWF	month
	MOVLW	0x0	; year   = I2C_Read(0); read year from register 6
	CALL	I2C_Read
	MOVWF	LCD_Char
	MOVF	LCD_Char, W
	MOVLB	0x0
	MOVWF	year
	CALL	I2C_Stop	; I2C_Stop(); stop I2C
	RETURN 
	
;*******************************************************************************	
; void alarms_read_display()  read and display alarm1 and alarm2 data function
;           {
;            uint8_t control_reg, temperature_lsb;
;            int8_t temperature_msb;
;*******************************************************************************
	
alarms_read_display:

	CALL	I2C_Start	; I2C_Start();start I2C
	MOVLW	0xD0	; I2C_Write(0xD0); RTC chip address
	CALL	I2C_Write
	MOVLW	0x8	; I2C_Write(0x08); send register address (alarm1 minutes register)
	CALL	I2C_Write
	CALL	I2C_Repeated_Start	; I2C_Repeated_Start(); restart I2C
	MOVLW	0xD1	; I2C_Write(0xD1); initialize data read
	CALL	I2C_Write
	MOVLW	0x1	; alarm1_minute = I2C_Read(1); ead alarm1 minutes
	CALL	I2C_Read
	MOVWF	number
	MOVF	number, W
	MOVLB	0x0
	MOVWF	alarm1_minute
	MOVLW	0x1	; alarm1_hour   = I2C_Read(1); read alarm1 hours
	CALL	I2C_Read
	MOVWF	number
	MOVF	number, W
	MOVLB	0x0
	MOVWF	alarm1_hour
	MOVLW	0x1	; I2C_Read(1); skip alarm1 day/date register
	CALL	I2C_Read
	MOVLW	0x1	; alarm2_minute = I2C_Read(1); read alarm2 minutes
	CALL	I2C_Read
	MOVWF	number
	MOVF	number, W
	MOVLB	0x0
	MOVWF	alarm2_minute
	MOVLW	0x1	; alarm2_hour   = I2C_Read(1); read alarm2 hours
	CALL	I2C_Read
	MOVWF	number
	MOVF	number, W
	MOVLB	0x0
	MOVWF	alarm2_hour
	MOVLW	0x1	; I2C_Read(1); skip alarm2 day/date register
	CALL	I2C_Read
	MOVLW	0x1	; control_reg = I2C_Read(1); read control register
	CALL	I2C_Read
	MOVWF	number
	MOVF	number, W
	MOVLB	0x0
	MOVWF	__pcstackBANK0
	MOVLW	0x1	; status_reg  = I2C_Read(1); read status register
	CALL	I2C_Read
	MOVWF	number
	MOVF	number, W
	MOVLB	0x0
	MOVWF	status_reg
	MOVLW	0x1	; I2C_Read(1); skip aging offset register
	CALL	I2C_Read
	MOVLW	0x1	; temperature_msb = I2C_Read(1); read temperature MSB
	CALL	I2C_Read
	MOVF	number, W
	MOVLB	0x0
	MOVWF	al
	MOVLW	0x0	; temperature_lsb = I2C_Read(0); read temperature LSB
	CALL	I2C_Read
	MOVWF	number
	MOVF	number, W
	MOVLB	0x0
	MOVWF	x
	CALL	I2C_Stop	; I2C_Stop(); stop I2C
; convert BCD to decimal
; alarm1_minute = bcd_to_decimal(alarm1_minute);
	MOVLB	0x0
	MOVF	alarm1_minute, W
	CALL	bcd_to_decimal
	MOVWF	number
	MOVF	number, W
	MOVLB	0x0
	MOVWF	alarm1_minute
; alarm1_hour   = bcd_to_decimal(alarm1_hour);
	MOVF	alarm1_hour, W
	CALL	bcd_to_decimal
	MOVWF	number
	MOVF	number, W
	MOVLB	0x0
	MOVWF	alarm1_hour
	; alarm2_minute = bcd_to_decimal(alarm2_minute);
	MOVF	alarm2_minute, W
	CALL	bcd_to_decimal
	MOVWF	number
	MOVF	number, W
	MOVLB	0x0
	MOVWF	alarm2_minute
	; alarm2_hour   = bcd_to_decimal(alarm2_hour);
	MOVF	alarm2_hour, W
	CALL	bcd_to_decimal
	MOVWF	number
	MOVF	number, W
	MOVLB	0x0
	MOVWF	alarm2_hour
	; end conversion
	; update Alarm1 and Alarm2
	; Alarm1[8]     = alarm1_minute % 10  + '0';
	MOVLW	0xA
	MOVWF	__pcstackCOMMON
	MOVLW	0x0
	MOVF	alarm1_minute, W
	MOVWF	number
	CLRF	0x7A
	MOVF	number, W
	MOVWF	dividend
	MOVF	0x7A, W
	MOVWF	LCD_Char
	CALL	__awmod
	MOVF	__pcstackCOMMON, W
	ADDLW	0x30
	MOVWF	0x7B
	MOVF	0x7B, W
	MOVLB	0x0
	MOVWF	0x28
; Alarm1[7]     = alarm1_minute / 10  + '0';
	MOVLW	0xA
	MOVWF	__pcstackCOMMON
	MOVLW	0x0
	MOVWF	n
	MOVF	alarm1_minute, W
	MOVWF	number
	CLRF	0x7A
	MOVF	number, W
	MOVWF	dividend
	MOVF	0x7A, W
	MOVWF	LCD_Char
	CALL	__awdiv
	MOVF	__pcstackCOMMON, W
	MOVWF	0x7B
	MOVF	0x7B, W
	MOVLB	0x0
	MOVWF	0x27
; Alarm1[5]     = alarm1_hour   % 10  + '0';
	MOVLW	0xA
	MOVWF	__pcstackCOMMON
	MOVLW	0x0
	MOVWF	n
	MOVF	alarm1_hour, W
	MOVWF	number
	CLRF	0x7A
	MOVF	number, W
	MOVWF	dividend
	MOVF	0x7A, W
	MOVWF	LCD_Char
	CALL	__awmod
	MOVF	__pcstackCOMMON, W
	ADDLW	0x30
	MOVWF	0x7B
	MOVF	0x7B, W
	MOVLB	0x0
	MOVWF	0x25
; Alarm1[4]     = alarm1_hour   / 10  + '0';
	MOVLW	0xA
	MOVWF	__pcstackCOMMON
	MOVLW	0x0
	MOVWF	n
	MOVF	alarm1_hour, W
	MOVWF	number
	CLRF	0x7A
	MOVF	number, W
	MOVWF	dividend
	MOVF	0x7A, W
	MOVWF	LCD_Char
	CALL	__awdiv
	MOVF	__pcstackCOMMON, W
	ADDLW	0x30
	MOVWF	0x7B
	MOVF	0x7B, W
	MOVLB	0x0
	MOVWF	0x24
; Alarm2[8]     = alarm2_minute % 10  + '0';
	MOVLW	0xA
	MOVWF	__pcstackCOMMON
	MOVLW	0x0
	MOVWF	n
	MOVF	alarm2_minute, W
	MOVWF	number
	CLRF	0x7A
	MOVF	number, W
	MOVWF	dividend
	MOVF	0x7A, W
	MOVWF	LCD_Char
	CALL	__awmod
	MOVF	__pcstackCOMMON, W
	ADDLW	0x30
	MOVWF	0x7B
	MOVF	0x7B, W
	MOVLB	0x1
	MOVWF	0xA8
; Alarm2[7]     = alarm2_minute / 10  + '0';
	MOVLW	0xA
	MOVWF	0xF0
	MOVLW	0x0
	MOVWF	0xF1
	MOVLB	0x0
	MOVF	alarm2_minute, W
	MOVWF	number
	CLRF	0x7A
	MOVF	number, W
	MOVWF	dividend
	MOVF	0x7A, W
	MOVWF	LCD_Char
	CALL	__awdiv
	MOVF	__pcstackCOMMON, W
	ADDLW	0x30
	MOVWF	0x7B
	MOVF	0x7B, W
	MOVLB	0x1
	MOVWF	0xA7
; Alarm2[5]     = alarm2_hour   % 10  + '0';
	MOVLW	0xA
	MOVWF	0xF0
	MOVLW	0x0
	MOVWF	0xF1
	MOVLB	0x0
	MOVF	alarm2_hour, W
	MOVWF	number
	CLRF	0x7A
	MOVF	number, W
	MOVWF	dividend
	MOVF	0x7A, W
	MOVWF	LCD_Char
	CALL	__awmod
	MOVF	__pcstackCOMMON, W
	ADDLW	0x30
	MOVWF	0x7B
	MOVF	0x7B, W
	MOVLB	0x1
	MOVWF	0xA5
; Alarm2[4]     = alarm2_hour   / 10  + '0';
	MOVLW	0xA
	MOVWF	0xF0
	MOVLW	0x0
	MOVWF	0xF1
	MOVLB	0x0
	MOVF	alarm2_hour, W
	MOVWF	number
	CLRF	0x7A
	MOVF	number, W
	MOVWF	dividend
	MOVF	0x7A, W
	MOVWF	LCD_Char
	CALL	__awdiv
	MOVF	__pcstackCOMMON, W
	ADDLW	0x30
	MOVWF	0x7B
	MOVF	0x7B, W
	MOVLB	0x1
	MOVWF	0xA4
; alarm1_status = control_reg & 0x01;      // read alarm1 interrupt enable bit (A1IE) from RTC chip control register
	MOVLB	0x0
	MOVF	__pcstackBANK0, W
	ANDLW	0x1
	MOVWF	number
	MOVF	number, W
	MOVWF	alarm1_status
; alarm2_status = (control_reg >> 1) & 0x01; // read alarm2 interrupt enable bit (A2IE) from RTC chip control register
	LSRF	__pcstackBANK0, W
	ANDLW	0x1
	MOVWF	number
	MOVF	number, W
	MOVWF	alarm2_status
; if(temperature_msb < 0){
	BTFSS	al, 0x7
	GOTO	0x3C2
; temperature_msb *= -1;
	MOVF	al, W
	MOVWF	number
	MOVF	number, W
	MOVWF	__pcstackCOMMON
	MOVLW	0xFF
	CALL	0x560
	MOVWF	0x7A
	MOVF	0x7A, W
	MOVLB	0x0
	MOVWF	al
; Temperature[2] = '-';
	MOVLW	0x2D
	GOTO	A3C3
; }
; else
; Temperature[2] = ' ';
	MOVLW	0x20
A3C3:  
	MOVWF	number
	MOVF	number, W
	MOVWF	0x2F
; temperature_lsb >>= 6;
	SWAPF	x, F
	RRF	x, F
	RRF	x, F
	MOVLW	0x3
	ANDWF	x, F
; Temperature[4] = temperature_msb % 10  + '0';
	MOVLW	0xA
	MOVWF	__pcstackCOMMON
	MOVLW	0x0
	MOVWF	n
	MOVF	al, W
	MOVWF	dividend
	CLRF	LCD_Char
	BTFSC	dividend, 0x7
	DECF	LCD_Char, F
	CALL	__awmod
	MOVF	__pcstackCOMMON, W
	ADDLW	0x30
	MOVWF	number
	MOVF	number, W
	MOVLB	0x0
	MOVWF	0x31
; Temperature[3] = temperature_msb / 10  + '0';
	MOVLW	0xA
	MOVWF	__pcstackCOMMON
	MOVLW	0x0
	MOVWF	n
	MOVF	al, W
	MOVWF	dividend
	CLRF	LCD_Char
	BTFSC	dividend, 0x7
	DECF	LCD_Char, F
	CALL	__awdiv
	MOVF	__pcstackCOMMON, W
	ADDLW	0x30
	MOVWF	number
	MOVF	number, W
	MOVLB	0x0
	MOVWF	0x30
; if(temperature_lsb == 0 || temperature_lsb == 2){
	MOVF	x, W
	BTFSC	STATUS, 0x2
	GOTO	A3F6
	MOVLW	0x2
	XORWF	x, W
	BTFSS	STATUS, 0x2
	GOTO	0x403
; Temperature[7] = '0';
A3F6: 
	MOVLW	0x30
	MOVWF	number
	MOVF	number, W
	MOVWF	0x34
; if(temperature_lsb == 0) Temperature[6] = '0';
	MOVF	x, W
	BTFSS	STATUS, 0x2
	GOTO	A3FF
	MOVLW	0x30
	GOTO	A400
; else                     Temperature[6] = '5';
A3FF: 
	MOVLW	0x35
A400: 
	MOVWF	number
	MOVF	number, W
	MOVWF	0x33
; }
; if(temperature_lsb == 1 || temperature_lsb == 3){
	DECF	x, W
	BTFSC	STATUS, 0x2
	GOTO	A40A
	MOVLW	0x3
	XORWF	x, W
	BTFSS	STATUS, 0x2
	GOTO	A417
; Temperature[7] = '5';
A40A: 
	MOVLW	0x35
	MOVWF	number
	MOVF	number, W
	MOVWF	0x34
; if(temperature_lsb == 1) Temperature[6] = '2';
	DECF	x, W
	BTFSS	STATUS, 0x2
	GOTO	A413
	MOVLW	0x32
	GOTO	A414
; else                     Temperature[6] = '7';
A413:
	MOVLW	0x37
A414:
	MOVWF	number
	MOVF	number, W
	MOVWF	0x33
; }
; Temperature[8]  = 223;   // put degree symbol (°)
A417:	
	MOVLW	0xDF
	MOVWF	number
	MOVF	number, W
	MOVWF	0x35
; LCD_Goto(11, 1);
	CLRF	row
	INCF	row, F
	MOVLW	0xB
	CALL	LCD_Goto
; LCD_Print(Temperature);  // print temperature
	MOVLW	0x2D
	MOVWF	dividend
	MOVLW	0x0
	MOVWF	LCD_Char
	CALL	LCD_Print

; LCD_Goto(1, 3);
	MOVLW	0x3
	MOVWF	number
	MOVF	number, W
	MOVWF	row
	MOVLW	0x1
	CALL	LCD_Goto

; LCD_Print(Alarm1); print Alarm1
	MOVLW	0x20
	MOVWF	dividend
	MOVLW	0x0
	MOVWF	LCD_Char
	CALL	LCD_Print

; if(alarm1_status) {
	MOVLB	0x0
	MOVF	alarm1_status, W
	BTFSC	STATUS, 0x2
	GOTO	A447
; LCD_Goto(18, 3);
	MOVLW	0x3
	MOVWF	number
	MOVF	number, W
	MOVWF	row
	MOVLW	0x12
	CALL	LCD_Goto

; LCD_Print("ON "); if A1IE = 1 print 'ON'
	MOVLW	0x4
	MOVWF	dividend
	MOVLW	0x90
	GOTO	A452
; }
; else {
; LCD_Goto(18, 3);
A447:
	MOVLW	0x3	
	MOVWF	number
	MOVF	number, W
	MOVWF	row
	MOVLW	0x12
	CALL	LCD_Goto

; LCD_Print("OFF");   // if A1IE = 0 print 'OFF'
	MOVLW	0x8
	MOVWF	dividend
	MOVLW	0x90
A452:
	MOVWF	LCD_Char
	CALL	LCD_Print
; }
; LCD_Goto(1, 4);
	MOVLW	0x4
	MOVWF	number
	MOVF	number, W
	MOVWF	row
	MOVLW	0x1
	CALL	LCD_Goto

; LCD_Print(Alarm2);    // print Alarm2
	MOVLW	0xA0
	MOVWF	dividend
	MOVLW	0x0
	MOVWF	LCD_Char
	CALL	LCD_Print

; if(alarm2_status){
	MOVLB	0x0
	MOVF	alarm2_status, W
	BTFSC	STATUS, 0x2
	GOTO	A478
; LCD_Goto(18, 4);
	MOVLW	0x4
	MOVWF	number
	MOVF	number, W
	MOVWF	row
	MOVLW	0x12
	CALL	LCD_Goto

; LCD_Print("ON ");   // if A2IE = 1 print 'ON'
	MOVLW	0x4
	MOVWF	dividend
	MOVLW	0x90
	MOVWF	LCD_Char
	CALL	LCD_Print
	RETURN
; else {
; LCD_Goto(18, 4);
A478:
	MOVLW	0x4
	MOVWF	number
	MOVF	number, W
	MOVWF	row
	MOVLW	0x12
	CALL	LCD_Goto

; LCD_Print("OFF");   // if A2IE = 0 print 'OFF'
	MOVLW	0x8
	MOVWF	dividend
	MOVLW	0x90
	MOVWF	LCD_Char
	CALL	LCD_Print
	RETURN

;*******************************************************************************	
;		void w_day_display() print day of the week
;{
;             LCD_Goto(1, 2);
;*******************************************************************************	

w_day_display:
	
	MOVLW	0x2
	MOVWF	0x78
	MOVF	0x78, W
	MOVWF	row
	MOVLW	0x1
	CALL	LCD_Goto
; switch(w_day){
	MOVLB	0x0
	MOVF	w_day, W
	XORLW	0x1
	BTFSC	STATUS, 0x2
	GOTO	AFB9
	XORLW	0x3
	BTFSC	STATUS, 0x2
	GOTO	AFC0
	XORLW	0x1
	BTFSC	STATUS, 0x2
	GOTO	AFC7
	XORLW	0x7
	BTFSC	STATUS, 0x2
	GOTO	AFCE
	XORLW	0x1
	BTFSC	STATUS, 0x2
	GOTO	AFD5
	XORLW	0x3
	BTFSC	STATUS, 0x2
	GOTO	AFDC
	GOTO	AFE3
; case 1:  LCD_Print("Sun"); break;
AFB9:	
	MOVLW	0x1C
	MOVWF	dividend
	MOVLW	0x90
	MOVWF	LCD_Char
	CALL	LCD_Print
	RETURN
; case 2:  LCD_Print("Mon"); break;
AFC0:	
	MOVLW	0x18
	MOVWF	dividend
	MOVLW	0x90
	MOVWF	LCD_Char
	CALL	LCD_Print
	RETURN
; case 3:  LCD_Print("Tue"); break;
AFC7:	
	MOVLW	0x10
	MOVWF	dividend
	MOVLW	0x90
	MOVWF	LCD_Char
	CALL	LCD_Print
	RETURN
; case 4:  LCD_Print("Wed"); break;
AFCE:
	MOVLW	0xC
	MOVWF	dividend
	MOVLW	0x90
	MOVWF	LCD_Char
	CALL	LCD_Print
	RETURN
; case 5:  LCD_Print("Thu"); break;
AFD5:
	MOVLW	0x24
	MOVWF	dividend
	MOVLW	0x90
	MOVWF	LCD_Char
	CALL	LCD_Print
	RETURN
; case 6:  LCD_Print("Fri"); break;
AFDC:	
	MOVLW	0x14
	MOVWF	dividend
	MOVLW	0x90
	MOVWF	LCD_Char
	CALL	LCD_Print
	RETURN
; default: LCD_Print("Sat");
AFE3:
	MOVLW	0x20
	MOVWF	dividend
	MOVLW	0x90
	MOVWF	LCD_Char
	CALL	LCD_Print            
	RETURN

;*******************************************************************************	
;          // edit time and date function
;           uint8_t edit(uint8_t x, uint8_t y, uint8_t parameter)
;*******************************************************************************
	
edit:	
	MOVLB	0x00
	MOVWF	x		
A5C9:	;while(debounce(1) || debounce(3));Schleife solange Button 1 oder Button 3 bettigt
	MOVLW	0x1
	CALL	debounce
	BTFSC	STATUS, 0x0
	GOTO	A5C9
	MOVLW	0x3
	CALL	debounce
	BTFSS	STATUS, 0x0
	GOTO	TestButt2
	GOTO	A5C9
	
TestButt2:
	movf	PORTB,w		; while(!button2) if button B2 is pressed
	ANDWF	0x4,w
	BTFSS	STATUS, 2
	GOTO	TestButt2
	goto	ParaHours		
ParaHours:
	MOVLW	1		; parameter++;
	ADDWF	parameter, F	; al = parameter
	MOVF	i, W		; if(((i == 0) || (i == 5)) && parameter > 23)
	BTFSC	STATUS, 2	; if hours > 23 ==> hours = 0
	GOTO	SetHours
	MOVLW	5
	XORWF	i, W
	BTFSS	STATUS, 2
	GOTO	ParaMinutes
SetHours:
	MOVLW	24
	SUBWF	parameter, W
	BTFSC	STATUS, 0               
	CLRF	parameter	; parameter = 0;
ParaMinutes:
	DECF	i, W		; if(((i == 1) || (i == 6)) && parameter > 59)  
	BTFSC	STATUS, 0x2	; if minutes > 59 ==> minutes = 0
	GOTO	SetMinutes
	MOVLW	6
	XORWF	i, W
	BTFSS	STATUS, 0x2
	GOTO	ParaDate
SetMinutes:	
	MOVLW	60
	SUBWF	parameter, W
	BTFSC	STATUS, 0             
	CLRF	parameter	; parameter = 0;
ParaDate:
	MOVLW	2		; if(i == 2 && parameter > 31)
	XORWF	i, W		; if date > 31 ==> date = 1
	BTFSS	STATUS, 2
	GOTO	ParaMonth
	MOVLW	32
	SUBWF	parameter, W
	BTFSS	STATUS, 0
	GOTO	ParaMonth			
	CLRF	parameter	; parameter = 1;
	INCF	parameter, F	
ParaMonth:
	MOVLW	3		; if(i == 3 && parameter > 12)   
	XORWF	i, W		; if month > 12 ==> month = 1
	BTFSS	STATUS, 2
	GOTO	ParaYear
	MOVLW	13
	SUBWF	parameter, W
	BTFSS	STATUS, 0
	GOTO	ParaYear
	CLRF	parameter	; parameter = 1;
	INCF	parameter, F
ParaYear:
	MOVLW	4		; if(i == 4 && parameter > 99)
	XORWF	i, W		; if year > 99 ==> year = 0
	BTFSS	STATUS, 2
	GOTO	ParaAlarms
	MOVLW	0x64
	SUBWF	parameter, W
	BTFSS	STATUS, 0
	GOTO	ParaAlarms
	CLRF	parameter	; parameter = 0;
ParaAlarms:
	MOVLW	7		; if(i == 7 && parameter > 1)
	XORWF	i, W		; for alarms ON or OFF (1: alarm ON, 0: alarm OFF)
	BTFSS	STATUS, 2
	GOTO	LcdGotoEdit
	MOVLW	0x2
	SUBWF	parameter, W
	BTFSS	STATUS, 0
	GOTO	LcdGotoEdit
	CLRF	parameter	; parameter = 0;
	
LcdGotoEdit:          
; LCD_Goto(x, y);
	MOVF	__pcstackBANK0, W
	MOVWF	0x7C
	MOVF	0x7C, W
	MOVWF	row
	MOVF	x, W
	CALL	LCD_Goto
; LCD_PutC(parameter / 10 + '0');
	MOVLW	0xA
	MOVWF	__pcstackCOMMON
	MOVLW	0x0
	MOVWF	button
	MOVLB	0x0
	MOVF	al, W
	MOVWF	0x7C
	CLRF	counter
	MOVF	0x7C, W
	MOVWF	count
	MOVF	counter, W
	MOVWF	i
	CALL	__awdiv
	MOVF	__pcstackCOMMON, W
	ADDLW	0x30
	CALL	LCD_PutC
; LCD_PutC(parameter % 10 + '0');
	MOVLW	0xA
	MOVWF	__pcstackCOMMON
	MOVLW	0x0
	MOVWF	button
	MOVLB	0x0
	MOVF	al, W
	MOVWF	0x7C
	CLRF	counter
	MOVF	0x7C, W
	MOVWF	count
	MOVF	counter, W
	MOVWF	i
	CALL	__awmod
	MOVF	__pcstackCOMMON, W
	ADDLW	0x30
	CALL	LCD_PutC         
; if(i >= 5){
	MOVLW	0x5
	MOVLB	0x0
	SUBWF	i, W
	BTFSS	STATUS, 0x0
	GOTO	A65F
	CALL	RTC_read	 ; read data from RTC chip
	CALL	RTC_display	; display time and date
	CALL	Wait     ;__delay_ms(200);
; LCD_Goto(x, y);
	MOVF	__pcstackBANK0, W
	MOVWF	0x7C
	MOVF	0x7C, W
	MOVWF	row
	MOVF	x, W
	CALL	LCD_Goto
; LCD_Print("  ");  // print 2 spaces
	MOVLW	0x1
	MOVWF	count
	MOVLW	0x90
	MOVWF	i
	CALL	LCD_Print
	CALL	blink 
; LCD_Goto(x, y);
	MOVLB	0x0
	MOVF	__pcstackBANK0, W
	MOVWF	0x7C
	MOVF	0x7C, W
	MOVWF	row
	MOVF	x, W
	CALL	LCD_Goto
; LCD_PutC(parameter / 10 + '0');
	MOVLW	0xA
	MOVWF	__pcstackCOMMON
	MOVLW	0x0
	MOVWF	button
	MOVLB	0x0
	MOVF	al, W
	MOVWF	0x7C
	CLRF	counter
	MOVF	0x7C, W
	MOVWF	count
	MOVF	counter, W
	MOVWF	i
	MOVLP	0xF
	CALL	__awdiv
	MOVLP	0x5
	MOVF	__pcstackCOMMON, W
	ADDLW	0x30
	CALL	LCD_PutC

; LCD_PutC(parameter % 10 + '0');
	MOVLW	0xA
	MOVWF	__pcstackCOMMON
	MOVLW	0x0
	MOVWF	button
	MOVLB	0x0
	MOVF	al, W
	MOVWF	0x7C
	CLRF	counter
	MOVF	0x7C, W
	MOVWF	count
	MOVF	counter, W
	MOVWF	i
	CALL	__awmod
	MOVF	__pcstackCOMMON, W
	ADDLW	0x30
	CALL	LCD_PutC
	CALL	blink    
; if(i >= 5)
A6B4:
	MOVLW	0x5
	MOVLB	0x0
	SUBWF	i, W
	BTFSS	STATUS, 0x0
	GOTO	A6BF
	CALL	RTC_read
	CALL	RTC_display
; if((!button1 && i < 5) || (!button3 && i >= 5)) if B1 or B3 is pressed
A6BF:
	MOVLB	0x0
A6C0:
	BTFSC	PORTB, 0x1
	GOTO	RTC1
	MOVLW	0x5
	SUBWF	i, W
	BTFSS	STATUS, 0x0
	GOTO	A6CC
RTC1:
	BTFSC	PORTB, 0x3
	GOTO	A66B
	MOVLW	0x5
	SUBWF	i, W
	BTFSS	STATUS, 0x0
	GOTO	A66B
A6CC:	MOVLW	0x1	;i++; increment 'i' for the next parameter
	MOVWF	0x7C
	MOVF	0x7C, W
	ADDWF	i, F
	MOVF	al, W	; return parameter; return parameter value and exit
	RETURN
	
	
;          // display time and date function
;           void RTC_display()
;       // convert data from BCD format to decimal format
	
	
RTC_display:	
; second = bcd_to_decimal(second);
	MOVLB	0x0
	MOVF	second, W
	CALL	bcd_to_decimal
	MOVWF	number
	MOVF	number, W
	MOVLB	0x0
	MOVWF	second
; minute = bcd_to_decimal(minute);
	MOVF	minute, W
	CALL	bcd_to_decimal
	MOVWF	number
	MOVF	number, W
	MOVLB	0x0
	MOVWF	minute
; hour   = bcd_to_decimal(hour);
	MOVF	hour, W
	CALL	bcd_to_decimal
	MOVWF	number
	MOVF	number, W
	MOVLB	0x0
	MOVWF	hour
; m_day  = bcd_to_decimal(m_day);
	MOVF	m_day, W
	CALL	bcd_to_decimal
	MOVWF	number
	MOVF	number, W
	MOVLB	0x0
	MOVWF	m_day
; month  = bcd_to_decimal(month);
	MOVF	month, W
	CALL	bcd_to_decimal
	MOVWF	number
	MOVF	number, W
	MOVLB	0x0
	MOVWF	month
; year   = bcd_to_decimal(year);
	MOVF	year, W
	CALL	bcd_to_decimal
	MOVWF	number
	MOVF	number, W
	MOVLB	0x0
	MOVWF	year
; end conversion
; update time
; Time[7] = second % 10  + '0';
	MOVLW	0xA
	MOVWF	__pcstackCOMMON
	MOVLW	0x0
	MOVWF	n
	MOVF	second, W
	MOVWF	number
	CLRF	0x7A
	MOVF	number, W
	MOVWF	dividend
	MOVF	0x7A, W
	MOVWF	LCD_Char
	CALL	__awmod
	MOVF	__pcstackCOMMON, W
	ADDLW	0x30
	MOVWF	0x7B
	MOVF	0x7B, W
	MOVLB	0x0
	MOVWF	0x4A
; Time[6] = second / 10  + '0';
	MOVLW	0xA
	MOVWF	__pcstackCOMMON
	MOVLW	0x0
	MOVWF	n
	MOVF	second, W
	MOVWF	number
	CLRF	0x7A
	MOVF	number, W
	MOVWF	dividend
	MOVF	0x7A, W
	MOVWF	LCD_Char
	CALL	__awdiv
	MOVF	__pcstackCOMMON, W
	ADDLW	0x30
	MOVWF	0x7B
	MOVF	0x7B, W
	MOVLB	0x0
	MOVWF	0x49
; Time[4] = minute % 10  + '0';
	MOVLW	0xA
	MOVWF	__pcstackCOMMON
	MOVLW	0x0
	MOVWF	n
	MOVF	minute, W
	MOVWF	number
	CLRF	0x7A
	MOVF	number, W
	MOVWF	dividend
	MOVF	0x7A, W
	MOVWF	LCD_Char
	CALL	__awmod
	MOVF	__pcstackCOMMON, W
	ADDLW	0x30
	MOVWF	0x7B
	MOVF	0x7B, W
	MOVLB	0x0
	MOVWF	0x47
; Time[3] = minute / 10  + '0';
	MOVLW	0xA
	MOVWF	__pcstackCOMMON
	MOVLW	0x0
	MOVWF	n
	MOVF	minute, W
	MOVWF	number
	CLRF	0x7A
	MOVF	number, W
	MOVWF	dividend
	MOVF	0x7A, W
	MOVWF	LCD_Char
	CALL	__awdiv
	MOVF	__pcstackCOMMON, W
	ADDLW	0x30
	MOVWF	0x7B
	MOVF	0x7B, W
	MOVLB	0x0
	MOVWF	0x46
; Time[1] = hour   % 10  + '0';
	MOVLW	0xA
	MOVWF	__pcstackCOMMON
	MOVLW	0x0
	MOVWF	n
	MOVF	hour, W
	MOVWF	number
	CLRF	0x7A
	MOVF	number, W
	MOVWF	dividend
	MOVF	0x7A, W
	MOVWF	LCD_Char
	CALL	__awmod
	MOVF	__pcstackCOMMON, W
	ADDLW	0x30
	MOVWF	0x7B
	MOVF	0x7B, W
	MOVLB	0x0
	MOVWF	0x44
; Time[0] = hour   / 10  + '0';
	MOVLW	0xA
	MOVWF	__pcstackCOMMON
	MOVLW	0x0
	MOVWF	n
	MOVF	hour, W
	MOVWF	number
	CLRF	0x7A
	MOVF	number, W
	MOVWF	dividend
	MOVF	0x7A, W
	MOVWF	LCD_Char
	CALL	__awdiv
	MOVF	__pcstackCOMMON, W
	ADDLW	0x30
	MOVWF	0x7B
	MOVF	0x7B, W
	MOVLB	0x0
	MOVWF	Time
;  update date
; Date[9] = year  % 10 + '0';
	MOVLW	0xA
	MOVWF	__pcstackCOMMON
	MOVLW	0x0
	MOVWF	n
	MOVF	year, W
	MOVWF	number
	CLRF	0x7A
	MOVF	number, W
	MOVWF	dividend
	MOVF	0x7A, W
	MOVWF	LCD_Char
	CALL	__awmod
	MOVF	__pcstackCOMMON, W
	ADDLW	0x30
	MOVWF	0x7B
	MOVF	0x7B, W
	MOVLB	0x0
	MOVWF	0x41
; Date[8] = year  / 10 + '0';
	MOVLW	0xA
	MOVWF	__pcstackCOMMON
	MOVLW	0x0
	MOVWF	n
	MOVF	year, W
	MOVWF	number
	CLRF	0x7A
	MOVF	number, W
	MOVWF	dividend
	MOVF	0x7A, W
	MOVWF	LCD_Char
	CALL	__awdiv
	MOVF	__pcstackCOMMON, W
	ADDLW	0x30
	MOVWF	0x7B
	MOVF	0x7B, W
	MOVLB	0x0
	MOVWF	0x40
; Date[4] = month % 10 + '0';
	MOVLW	0xA
	MOVWF	__pcstackCOMMON
	MOVLW	0x0
	MOVWF	n
	MOVF	month, W
	MOVWF	number
	CLRF	0x7A
	MOVF	number, W
	MOVWF	dividend
	MOVF	0x7A, W
	MOVWF	LCD_Char
	CALL	__awmod
	MOVF	__pcstackCOMMON, W
	ADDLW	0x30
	MOVWF	0x7B
	MOVF	0x7B, W
	MOVLB	0x0
	MOVWF	0x3C
; Date[3] = month / 10 + '0';
	MOVLW	0xA
	MOVWF	__pcstackCOMMON
	MOVLW	0x0
	MOVWF	n
	MOVF	month, W
	MOVWF	number
	CLRF	0x7A
	MOVF	number, W
	MOVWF	dividend
	MOVF	0x7A, W
	MOVWF	LCD_Char
	CALL	__awdiv
	MOVF	__pcstackCOMMON, W
	ADDLW	0x30
	MOVWF	0x7B
	MOVF	0x7B, W
	MOVLB	0x0
	MOVWF	0x3B
; Date[1] = m_day  % 10 + '0';
	MOVLW	0xA
	MOVWF	__pcstackCOMMON
	MOVLW	0x0
	MOVWF	n
	MOVF	m_day, W
	MOVWF	number
	CLRF	0x7A
	MOVF	number, W
	MOVWF	dividend
	MOVF	0x7A, W
	MOVWF	LCD_Char
	CALL	__awmod
	MOVF	__pcstackCOMMON, W
	ADDLW	0x30
	MOVWF	0x7B
	MOVF	0x7B, W
	MOVLB	0x0
	MOVWF	0x39
; Date[0] = m_day  / 10 + '0';
	MOVLW	0xA
	MOVWF	__pcstackCOMMON
	MOVLW	0x0
	MOVWF	n
	MOVF	m_day, W
	MOVWF	number
	CLRF	x7A
	MOVF	number, W
	MOVWF	dividend
	MOVF	0x7A, W
	MOVWF	LCD_Char
	CALL	__awdiv
	MOVF	__pcstackCOMMON, W
	ADDLW	0x30
	MOVWF	0x7B
	MOVF	0x7B, W
	MOVLB	0x0
	MOVWF	Date        
; LCD_Goto(1, 1);    // go to column 1, row 1
	CLRF	row
	INCF	row, F
	MOVLW	0x1
	CALL	LCD_Goto
; LCD_Print(Time);   // print time
	MOVLW	0x43
	MOVWF	dividend
	MOVLW	0x0
	MOVWF	LCD_Char
	CALL	LCD_Print
; LCD_Goto(5, 2);    // go to column 1, row 2
	MOVLW	0x2
	MOVWF	number
	MOVF	number, W
	MOVWF	row
	MOVLW	0x5
	CALL	LCD_Goto
; LCD_Print(Date);   // print date
	MOVLW	0x38
	MOVWF	dividend
	MOVLW	0x0
	MOVWF	LCD_Char
	CALL	LCD_Print
; w_day_display();   // print day of the week
	CALL	w_day_display
	RETURN
	
;*******************************************************************************
;          uint8_t on_off(uint8_t x, uint8_t y, uint8_t al)
;*******************************************************************************
	
on_off:	
	MOVLB	0x0
	MOVWF	x
A6C6:	; while(debounce(3)); call debounce function (wait for B3 to be released)
	MOVLW	0x3
	CALL	debounce
	BTFSS	STATUS, 0x0
	GOTO	A6FA
	GOTO	A6C6
A6FA:	; while(!button2) if button B2 is pressed
	MOVLB	0x0
	BTFSS	PORTB, 0x2
	GOTO	A6CD
A6CD:	; al = (!al) & 0x01;
	MOVF	al, W
	BTFSS	STATUS, 0x2
	GOTO	A6D2
	MOVLW	0x1
	GOTO	A6D3
A6D2:
	MOVLW	0x0
A6D3:
	ANDLW	0x1
	MOVWF	0x7C
	MOVF	0x7C, W
	MOVWF	al
	MOVF	__pcstackBANK0, W	; LCD_Goto(x, y);
	MOVWF	0x7C
	MOVF	0x7C, W
	MOVWF	row
	MOVF	x, W
	CALL	LCD_Goto
	MOVLB	0x0	; if(al == 1)  LCD_Print("ON ");
	DECF	al, W
	BTFSS	STATUS, 0x2
	GOTO	A6E7
	MOVLW	0x4
	MOVWF	dividend
	MOVLW	0x90
	GOTO	A6EA
A6E7:	; else LCD_Print("OFF");
	MOVLW	0x8
	MOVWF	dividend
	MOVLW	0x90
A6EA:
	MOVWF	LCD_Char
	CALL	LCD_Print
	CALL	Wait   ;__delay_ms(200);
	MOVF	__pcstackBANK0, W; LCD_Goto(x, y);
	MOVWF	0x7C
	MOVF	0x7C, W
	MOVWF	row
	MOVF	x, W
	CALL	LCD_Goto
	MOVLW	0x0	; LCD_Print("   "); print 3 spaces
	MOVWF	dividend
	MOVLW	0x90
	MOVWF	LCD_Char
	CALL	LCD_Print
	CALL	blink	; blink();          
	MOVLB	0x0	; LCD_Goto(x, y);
	MOVF	__pcstackBANK0, W
	MOVWF	0x7C
	MOVF	0x7C, W
	MOVWF	row
	MOVF	x, W
	CALL	LCD_Goto
	MOVLB	0x0	; if(al == 1)  LCD_Print("ON ");
	DECF	al, W
	BTFSS	STATUS, 0x2
	GOTO	A720
	MOVLW	0x4
	MOVWF	dividend
	MOVLW	0x90
	GOTO	A723
A720:	; else LCD_Print("OFF");
	MOVLW	0x8
	MOVWF	dividend
	MOVLW	0x90
A723:
	MOVWF	LCD_Char
	CALL	LCD_Print
	CALL	blink	; blink();
	CALL	RTC_read	; RTC_read();
	CALL	RTC_display	; RTC_display();   
	MOVLB	0x0	; if(!button3)
	BTFSC	PORTB, 0x3
	GOTO	A6FA
	MOVLW	0x3	; if(debounce(3))
	CALL	debounce
	BTFSS	STATUS, 0x0
	GOTO	A6FA
	MOVLB	0x0	; return al; 
	MOVF	al, W
	RETURN
       