
; File:     main.S
; Target:   PIC16F18677
; Author:   ARudi
; Date:     .........
; Compiler: pic-as(v2.20)
; IDE:      MPLABX v5.40
;
; Description:
;
; Add this line in the project properties box, pic-as Global Options -> Additional options: 
;    -Wl,-DCODE=2 -Wl,-pPor_Vec=0h,-pIsr_Vec=4h
;
;
PROCESSOR   16F18877
	
	
#include <xc.inc>	
; PIC16F18877 Configuration Bit Settings

; CONFIG1
config FEXTOSC =    ECM   ; External Oscillator mode selection bits->Oscillator not enabled
config RSTOSC =	    HFINT1    ; Power-up default value for COSC bits->HFINTOSC (1MHz)
config CLKOUTEN =   OFF    ; Clock Out Enable bit->CLKOUT function is disabled; i/o or oscillator function on OSC2
config CSWEN =	    ON    ; Clock Switch Enable bit->Writing to NOSC and NDIV is allowed
config FCMEN =	    ON    ; Fail-Safe Clock Monitor Enable bit->FSCM timer enabled

; CONFIG2
config MCLRE =	    ON    ; Master Clear Enable bit->MCLR pin is Master Clear function
config PWRTE =	    OFF    ; Power-up Timer Enable bit->PWRT disabled
config LPBOREN =    OFF  ; Low-Power BOR enable bit->ULPBOR disabled
config BOREN =	    ON    ; Brown-out reset enable bits->Brown-out Reset Enabled, SBOREN bit is ignored
config BORV =	    LO    ; Brown-out Reset Voltage Selection->Brown-out Reset Voltage (VBOR) set to 1.9V on LF, and 2.45V on F Devices
config ZCD =	    OFF    ; Zero-cross detect disable->Zero-cross detect circuit is disabled at POR.
config PPS1WAY =    ON    ; Peripheral Pin Select one-way control->The PPSLOCK bit can be cleared and set only once in software
config STVREN =	    ON    ; Stack Overflow/Underflow Reset Enable bit->Stack Overflow or Underflow will cause a reset

; CONFIG3
config WDTCPS = WDTCPS_31    ; WDT Period Select bits->Divider ratio 1:65536; software control of WDTPS
config WDTE =	OFF    ; WDT operating mode->WDT Disabled, SWDTEN is ignored
config WDTCWS = WDTCWS_7    ; WDT Window Select bits->window always open (100%); software control; keyed access not required
config WDTCCS = SC    ; WDT input clock selector->Software Control

; CONFIG4
config WRT =	OFF    ; UserNVM self-write protection bits->Write protection off
config SCANE =	available    ; Scanner Enable bit->Scanner module is available for use
config LVP =	ON    ; Low Voltage Programming Enable bit->Low Voltage programming enabled. MCLR/Vpp pin function is MCLR.

; CONFIG5
config CP =	OFF    ; UserNVM Program memory code protection bit->Program Memory code protection disabled
config CPD =	OFF    ; DataNVM code protection bit->Data EEPROM code protection disabled
	  
;*******************************************************************************
	


	
PSECT   udata
global	counter,i,ButtonFlags,loops,loops2,parameter,second,minute,hour,w_day,m_day
global	month,year,alarm1_minute,alarm1_hour,alarm2_minute,alarm2_hour
global	status_reg,alarm1_status,alarm2_status ,x,button,Date,col,sign,multiplier
global   product,quotient,Time
	
	counter:		DS      1               
	i:		DS      1 
	ButtonFlags:	DS	1
	loops:		DS	1
	loops2:		DS	1
	parameter:	DS	1
	second:		DS      1               
	minute:		DS      1
	hour:		DS      1
	w_day:		DS	1   
	m_day:		DS	1  
	month:		DS	1	
	year:		DS	1 
	alarm1_minute:	DS	1	
	alarm1_hour:	DS	1 
	alarm2_minute:	DS	1	
	alarm2_hour:	DS	1
	status_reg:	DS	1	
	alarm1_status:	DS	1 
	alarm2_status:	DS	1 
	x:		DS      1
	button:		DS	1   
	Date:		DS	1  
	col:		DS	1	
	sign:		DS	1 
	multiplier:	DS	1   
	product:	DS	1  
	quotient:	DS	1
	Time:		DS	1
	
;*******************************************************************************	
PSECT udata_shr
 global __pcstackBANK0,al,row,number,__pcstackCOMMON,n,dividend,LCD_Char,LCD_Str
 
	__pcstackBANK0:	DS      1               
	al:		DS      1 
	row:		DS	1
	number:		DS	1
	__pcstackCOMMON:DS	1
	n:		DS	1
	dividend:	DS      1               
	LCD_Char:	DS      1
	LCD_Str:	DS      1
 
;*******************************************************************************	

#define		Button_1	ButtonFlags,1
#define		Button_3        ButtonFlags,3	; 1: Temperatur ist negativ
	

PSECT   Por_Vec,global,class=CODE,delta=2
 
resetVec:
	pagesel Start
	goto	Start
	
PSECT   Isr_Vec,global,class=CODE,delta=2
    
Isr_Vec:
	BSF 0x7E, 0x0
	MOVLP 0x0
	MOVLB 0xE
	BTFSS PIR0, 0x0
	GOTO 0xD
	MOVLB 0x0
	BSF PORTB, 0x4
	MOVLB 0xE
	BCF PIR0, 0x0
	BCF 0x77E, 0x0
	RETFIE
Start:
	;Time:
	;IRPC char,  :  :  
	;DB 'char'
	;ENDM
	
	
; Initialize the PIC hardware 
;MOVLB	0x0	; Bank 0
	;CLRF    TRISA	; TRIS = 0 = Out ;ist Standart 1 (ohne Init)
	;MOVLW	0XFF
	;MOVWF	TRISB
	;CLRF    TRISC
	;CLRF    TRISD
	;CLRF    TRISE
	;CLRF	LATA	; Data Latch Register ;ist Standart 0 (ohne Init)
	;CLRF	LATB
	;CLRF	LATC
	;CLRF	LATD
	;CLRF	LATE			
	;CLRF	PORTA	; 1 = Port pin is > V IH ;ist Standart 0 (ohne Init)
	;CLRF	PORTB	; 0 = Port pin is < V IL
	;CLRF	PORTC
	;CLRF	PORTD
	;CLRF	PORTE			
	;MOVLB   0x3E	; Bank 62
	;CLRF    ANSELA	; 1 = Analog input. ;ist Standart 1 (ohne Init)
	;CLRF    ANSELB	; 0 = Digital I/O. 
	;CLRF    ANSELC
	;CLRF    ANSELD
	;CLRF    ANSELE			
	;CLRF    WPUA	; 0= Pull-up disabled ;ist Standart 0 (ohne Init)
	;Clrf	WPUB	; 1 = Pull-up enabled 
	;CLRF    WPUC
	;CLRF    WPUD
	;CLRF    WPUE			
	;CLRF    ODCONA	; 0 = standard push-pull drive (source and sink current)
	;CLRF    ODCONB	; 1 = open-drain drive (sink current only) ;ist Standart 0 (ohne Init) 
	;CLRF    ODCONC
	;CLRF    ODCOND
	;CLRF	ODCONE
	;MOVLW   0xFF	; 1 = Port pin slew rate is limited
	;MOVWF	SLRCONA	; 0 = Port pin slews at maximum rate ;ist Standart 1 (ohne Init)
	;MOVWF   SLRCONB      
	;MOVWF   SLRCONC
	;MOVWF   SLRCOND
	;MOVLW   0x07
	;MOVWF   SLRCONE			
	;MOVLW   0xFF	; 1 = ST input used for PORT reads and interrupt-on-change ;ist Standart 1 (ohne Init)
	;MOVWF   INLVLA	; 0 = TTL input used for PORT reads and interrupt-on-change
	;MOVWF   INLVLB
	;MOVWF   INLVLC
	;MOVWF   INLVLD
	;MOVLW   0x0F
	;MOVWF   INLVLE
	

;*******************************************************************************
;				main function
;*******************************************************************************
	
;main:          
;	MOVLW	0x3		; OSCFRQ = 0x03; set internal oscillator to 8MHz
;	MOVLB	0x11
;	MOVWF	OSCFRQ
;	MOVLB	0x3E		; ANSELB = 0; configure all PORTB pins as digital
;	CLRF	ANSELB
;	MOVLB	0x0		; PORTB  = 0; PORTB initial state
;	CLRF	PORTB
;	MOVLW	0xF		; configure RB0 ~ 3 as input pins
;	MOVWF	TRISB
;	MOVLW	0xF		; enable RB0, RB1, RB2 and RB3 internal pull ups
;	MOVLB	0x3E
;	MOVWF	WPUB
;	MOVLB	0xE		; INTE   = 0; clear external interrupt flag bit
;	BCF	PIE0, 0x0
;	BSF	INTCON, 0x7	; GIE    = 1; enable global interrupts
;	BCF	INTCON, 0x0	; INTEDG = 0; set external Interrupt on falling edge
;	BSF	PIE0, 0x0	; INTE   = 1; enable external interrupt     
;	CALL	wait5ms		;__delay_ms(1000);  // wait 1 second  
;	CALL	I2C_Init	; I2C_Init(100000); initialize I2C bus with clock frequency of 100kHz
;	CALL	LCD_Begin	; initialize LCD module
	

	
;*******************************************************************************
;                               main
;*******************************************************************************

	
main:	MOVLW 0x3
	MOVLB 0x11
	MOVWF TRISC
	MOVLB 0x3E
	CLRF Time
	MOVLB 0x0
	CLRF PORTB
	MOVLW 0xF
	MOVWF TRISB
	MOVLW 0xF
	MOVLB 0x3E
	MOVWF 0x44
	MOVLB 0xE
	BCF PIE0, 0x0
	BSF INTCON, 0x7
	BCF INTCON, 0x0
	BSF PIE0, 0x0
	MOVLW 0xB	;__delay_ms(1000); wait 1 second
	MOVLB 0x0
	MOVWF 0x63
	MOVLW 0x26
	MOVWF 0x62
	MOVLW 0x5D
A04C:	DECFSZ WREG, F
	GOTO A04C
	DECFSZ 0x62, F
	GOTO A04C
	DECFSZ 0x63, F
	GOTO A04C
;	BRA 0x53
	MOVLP 0xD
	FCALL I2C_Init
	MOVLP 0x0
	MOVLP 0x7
	FCALL LCD_Begin
	
Mainloop:	MOVLP 0x0
	MOVLB 0x0
	BTFSC PORTB, 0x1
	GOTO 0x160
	MOVLW 0x1
	MOVLP 0xE
	FCALL debounce
	MOVLP 0x0
	BTFSS STATUS, 0x0
	GOTO 0x160
	MOVLB 0x0
	CLRF i
	CLRF __pcstackBANK0
	INCF __pcstackBANK0, F 
	MOVF hour, W
	MOVWF 0x62
	MOVF 0x62, W
	MOVWF al
	MOVLW 0x1
	MOVLP 0x5
	CALL edit
	MOVLP 0x0
	MOVLB 0x0
	MOVWF 0x63
	MOVF 0x63, W
	MOVWF hour
	CLRF __pcstackBANK0
	INCF __pcstackBANK0, F 
	MOVF minute, W
	MOVWF 0x62
	MOVF 0x62, W
	MOVWF al
	MOVLW 0x4
	MOVLP 0x5
	CALL edit
	MOVLP 0x0
	MOVLB 0x0
	MOVWF 0x63
	MOVF 0x63, W
	MOVWF minute
A080:	MOVLW 0x1
	MOVLP 0xE
	FCALL debounce
	MOVLP 0x0
	BTFSS STATUS, 0x0
	GOTO 0xA0
	GOTO 0x80
A087:	MOVLW 0x1
	MOVWF 0x62
	MOVF 0x62, W
	ADDWF w_day, F
	MOVLW 0x8
	SUBWF w_day, W
	BTFSS STATUS, 0x0
	GOTO 0x91
	CLRF w_day
	INCF w_day, F
A091:	MOVLP 0xF
	FCALL w_day_display
	MOVLP 0x0
	MOVLW 0x3
	MOVLB 0x0
	MOVWF 0x63
	MOVLW 0x8
	MOVWF 0x62
	MOVLW 0x77
A09A:	DECFSZ WREG, F
	GOTO A09A
	DECFSZ 0x62, F
	GOTO A09A
	DECFSZ 0x63, F
	GOTO A09A
A0A0:	MOVLB 0x0
	BTFSS PORTB, 0x2
	GOTO A087
	MOVLW 0x2
	MOVWF 0x62
	MOVF 0x62, W
	MOVWF row
	MOVLW 0x1
	MOVLP 0xD
	FCALL LCD_Goto
	MOVLP 0x0
	MOVLW 0x0
	MOVWF LCD_Str
	MOVLW 0x90
	MOVWF LCD_Char
	MOVLP 0xE
	FCALL LCD_Print
	MOVLP 0x0
	MOVLP 0xD
	FCALL blink
	MOVLP 0x0
	MOVLP 0xF
	FCALL w_day_display
	MOVLP 0x0
	MOVLP 0xD
	FCALL blink
	MOVLP 0x0
	MOVLB 0x0
	BTFSC PORTB, 0x1
	GOTO A0A0
	MOVLW 0x1
	MOVLP 0xE
	FCALL debounce
	MOVLP 0x0
	BTFSS STATUS, 0x0
	GOTO A0A0
	MOVLW 0x2
	MOVLB 0x0
	MOVWF 0x62
	MOVF 0x62, W
	MOVWF __pcstackBANK0
	MOVF m_day, W
	MOVWF 0x63
	MOVF 0x63, W
	MOVWF al
	MOVLW 0x5
	MOVLP 0x5
	CALL edit
	MOVLP 0x0
	MOVLB 0x0
	MOVWF 0x64
	MOVF 0x64, W
	MOVWF m_day
	MOVLW 0x2
	MOVWF 0x62
	MOVF 0x62, W
	MOVWF __pcstackBANK0
	MOVF month, W
	MOVWF 0x63
	MOVF 0x63, W
	MOVWF al
	MOVLW 0x8
	MOVLP 0x5
	CALL edit
	MOVLP 0x0
	MOVLB 0x0
	MOVWF 0x64
	MOVF 0x64, W
	MOVWF month
	MOVLW 0x2
	MOVWF 0x62
	MOVF 0x62, W
	MOVWF __pcstackBANK0
	MOVF year, W
	MOVWF 0x63
	MOVF 0x63, W
	MOVWF al
	MOVLW 0xD
	MOVLP 0x5
	CALL edit
	MOVLP 0x0
	MOVLB 0x0
	MOVWF 0x64
	MOVF 0x64, W
	MOVWF year
A0F5:	MOVLW 0x1
	MOVLP 0xE
	FCALL debounce
	MOVLP 0x0
	BTFSC STATUS, 0x0
	GOTO A0F5
	MOVLB 0x0
	MOVF minute, W
	MOVLP 0xE
	FCALL decimal_to_bcd
	MOVLP 0x0
	MOVLB 0x0
	MOVWF 0x62
	MOVF 0x62, W
	MOVWF minute
	MOVF hour, W
	MOVLP 0xE
	FCALL decimal_to_bcd
	MOVLP 0x0
	MOVLB 0x0
	MOVWF 0x62
	MOVF 0x62, W
	MOVWF hour
	MOVF m_day, W
	MOVLP 0xE
	FCALL decimal_to_bcd
	MOVLP 0x0
	MOVLB 0x0
	MOVWF 0x62
	MOVF 0x62, W
	MOVWF m_day
	MOVF month, W
	MOVLP 0xE
	FCALL decimal_to_bcd
	MOVLP 0x0
	MOVLB 0x0
	MOVWF 0x62
	MOVF 0x62, W
	MOVWF month
	MOVF year, W
	MOVLP 0xE
	FCALL decimal_to_bcd
	MOVLP 0x0
	MOVLB 0x0
	MOVWF 0x62
	MOVF 0x62, W
	MOVWF year
	MOVLP 0xD
	FCALL I2C_Start
	MOVLP 0x0
	MOVLW 0xD0
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x0
	MOVLW 0x0
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x0
	MOVLW 0x0
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x0
	MOVLB 0x0
	MOVF minute, W
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x0
	MOVLB 0x0
	MOVF hour, W
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x0
	MOVLB 0x0
	MOVF w_day, W
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x0
	MOVLB 0x0
	MOVF m_day, W
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x0
	MOVLB 0x0
	MOVF month, W
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x0
	MOVLB 0x0
	MOVF year, W
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x0
	MOVLP 0xD
	FCALL I2C_Stop
	MOVLP 0x0
	MOVLW 0x3
	MOVLB 0x0
	MOVWF 0x63
	MOVLW 0x8
	MOVWF 0x62
	MOVLW 0x77
A15A:	DECFSZ WREG, F
	GOTO 0x15A
	DECFSZ 0x62, F
	GOTO 0x15A
	DECFSZ 0x63, F
	GOTO 0x15A
A160:	MOVLB 0x0
	BTFSC PORTB, 0x3
	GOTO A23E
	MOVLW 0x3
	MOVLP 0xE
	FCALL debounce
	MOVLP 0x0
	BTFSS STATUS, 0x0
	GOTO A23E
	MOVLW 0x5
	MOVLB 0x0
	MOVWF 0x62
	MOVF 0x62, W
	MOVWF i
	MOVLW 0x3
	MOVWF 0x62
	MOVF 0x62, W
	MOVWF __pcstackBANK0
	MOVF alarm1_hour, W
	MOVWF 0x63
	MOVF 0x63, W
	MOVWF al
	MOVLW 0x5
	MOVLP 0x5
	CALL edit
	MOVLP 0x0
	MOVLB 0x0
	MOVWF 0x64
	MOVF 0x64, W
	MOVWF alarm1_hour
	MOVLW 0x3
	MOVWF 0x62
	MOVF 0x62, W
	MOVWF __pcstackBANK0
	MOVF alarm1_minute, W
	MOVWF 0x63
	MOVF 0x63, W
	MOVWF al
	MOVLW 0x8
	MOVLP 0x5
	CALL edit
	MOVLP 0x0
	MOVLB 0x0
	MOVWF 0x64
	MOVF 0x64, W
	MOVWF alarm1_minute
	MOVLW 0x3
	MOVWF 0x62
	MOVF 0x62, W
	MOVWF __pcstackBANK0
	MOVF alarm1_status, W
	MOVWF 0x63
	MOVF 0x63, W
	MOVWF al
	MOVLW 0x12
	MOVLP 0x6
	CALL on_off
	MOVLP 0x0
	MOVLB 0x0
	MOVWF 0x64
	MOVF 0x64, W
	MOVWF alarm1_status
	MOVLW 0x5
	MOVWF 0x62
	MOVF 0x62, W
	MOVWF i
	MOVLW 0x4
	MOVWF 0x62
	MOVF 0x62, W
	MOVWF __pcstackBANK0
	MOVF alarm2_hour, W
	MOVWF 0x63
	MOVF 0x63, W
	MOVWF al
	MOVLW 0x5
	MOVLP 0x5
	CALL edit
	MOVLP 0x0
	MOVLB 0x0
	MOVWF 0x64
	MOVF 0x64, W
	MOVWF alarm2_hour
	MOVLW 0x4
	MOVWF 0x62
	MOVF 0x62, W
	MOVWF __pcstackBANK0
	MOVF alarm2_minute, W
	MOVWF 0x63
	MOVF 0x63, W
	MOVWF al
	MOVLW 0x8
	MOVLP 0x5
	CALL edit
	MOVLP 0x0
	MOVLB 0x0
	MOVWF 0x64
	MOVF 0x64, W
	MOVWF alarm2_minute
	MOVLW 0x4
	MOVWF 0x62
	MOVF 0x62, W
	MOVWF __pcstackBANK0
	MOVF alarm2_status, W
	MOVWF 0x63
	MOVF 0x63, W
	MOVWF al
	MOVLW 0x12
	MOVLP 0x6
	CALL on_off
	MOVLP 0x0
	MOVLB 0x0
	MOVWF 0x64
	MOVF 0x64, W
	MOVWF alarm2_status
A1D2:	MOVLW 0x3
	MOVLP 0xE
	FCALL debounce
	MOVLP 0x0
	BTFSC STATUS, 0x0
	GOTO A1D2
	MOVLB 0x0
	MOVF alarm1_minute, W
	MOVLP 0xE
	FCALL decimal_to_bcd
	MOVLP 0x0
	MOVLB 0x0
	MOVWF 0x62
	MOVF 0x62, W
	MOVWF alarm1_minute
	MOVF alarm1_hour, W
	MOVLP 0xE
	FCALL decimal_to_bcd
	MOVLP 0x0
	MOVLB 0x0
	MOVWF 0x62
	MOVF 0x62, W
	MOVWF alarm1_hour
	MOVF alarm2_minute, W
	MOVLP 0xE
	FCALL decimal_to_bcd
	MOVLP 0x0
	MOVLB 0x0
	MOVWF 0x62
	MOVF 0x62, W
	MOVWF alarm2_minute
	MOVF alarm2_hour, W
	MOVLP 0xE
	FCALL decimal_to_bcd
	MOVLP 0x0
	MOVLB 0x0
	MOVWF 0x62
	MOVF 0x62, W
	MOVWF alarm2_hour
	MOVLP 0xD
	FCALL I2C_Start
	MOVLP 0x0
	MOVLW 0xD0
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x0
	MOVLW 0x7
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x0
	MOVLW 0x0
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x0
	MOVLB 0x0
	MOVF alarm1_minute, W
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x0
	MOVLB 0x0
	MOVF alarm1_hour, W
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x0
	MOVLW 0x80
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x0
	MOVLB 0x0
	MOVF alarm2_minute, W
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x0
	MOVLB 0x0
	MOVF alarm2_hour, W
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x0
	MOVLW 0x80
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x0
	MOVLB 0x0
	LSLF alarm2_status, W
	IORWF alarm1_status, W 
	IORLW 0x4
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x0
	MOVLW 0x0
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x0
	MOVLP 0xD
	FCALL I2C_Stop
	MOVLP 0x0
	MOVLW 0x3
	MOVLB 0x0
	MOVWF 0x63
	MOVLW 0x8
	MOVWF 0x62
	MOVLW 0x77
A238:	DECFSZ WREG, F
	GOTO A238
	DECFSZ 0x62, F
	GOTO A238
	DECFSZ 0x63, F
	GOTO A238
A23E:	MOVLB 0x0
	BTFSS PORTB, 0x2
	BTFSS PORTB, 0x4
	GOTO A272
	BCF PORTB, 0x4
	MOVLP 0xD
	FCALL I2C_Start
	MOVLP 0x0
	MOVLW 0xD0
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x0
	MOVLW 0xE
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x0
	MOVLB 0x0
	MOVF status_reg, W
	MOVWF 0x62
	MOVLW 0x1
A252:	LSRF 0x62, F
	DECFSZ WREG, F
	GOTO 0x252
	BTFSC 0x62, 0x0
	GOTO 0x259
	MOVLW 0x1
	GOTO 0x25A
A259:	MOVLW 0x0
A25A:	ANDWF alarm2_status, W 
	MOVWF 0x63
	MOVLW 0x1
A25D:	LSLF 0x63, F
	DECFSZ WREG, F
	GOTO A25D
	BTFSC status_reg, 0x0
	GOTO A264
	MOVLW 0x1
	GOTO A265
A264:	MOVLW 0x0
A265:	ANDWF alarm1_status, W 
	IORWF 0x63, W
	IORLW 0x4
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x0
	MOVLW 0x0
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x0
	MOVLP 0xD
	FCALL I2C_Stop
	MOVLP 0x0
A272:	MOVLP 0xF
	FCALL RTC_read
	MOVLP 0x0
	MOVLP 0x2
	CALL alarms_read_display
	MOVLP 0x0
	MOVLP 0x4
	CALL RTC_display
	MOVLP 0x0
	MOVLW 0x82
	MOVLB 0x0
	MOVWF 0x62
	MOVLW 0xDD
A27F:	DECFSZ WREG, F
	GOTO A27F
	DECFSZ 0x62, F
	GOTO A27F
;	BRA 0x284
	GOTO Mainloop
alarms_read_display:	MOVLP 0xD
	FCALL I2C_Start
	MOVLP 0x2
	MOVLW 0xD0
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x2
	MOVLW 0x8
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x2
	MOVLP 0xD
	FCALL I2C_Repeated_Start
	MOVLP 0x2
	MOVLW 0xD1
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x2
	MOVLW 0x1
	MOVLP 0xD
	FCALL I2C_Read
	MOVLP 0x2
	MOVWF number
	MOVF number, W
	MOVLB 0x0
	MOVWF alarm1_minute
	MOVLW 0x1
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x2
	MOVWF number
	MOVF number, W
	MOVLB 0x0
	MOVWF alarm1_hour
	MOVLW 0x1
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x2
	MOVLW 0x1
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x2
	MOVWF number
	MOVF number, W
	MOVLB 0x0
	MOVWF alarm2_minute
	MOVLW 0x1
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x2
	MOVWF number
	MOVF number, W
	MOVLB 0x0
	MOVWF alarm2_hour
	MOVLW 0x1
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x2
	MOVLW 0x1
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x2
	MOVWF number
	MOVF number, W
	MOVLB 0x0
	MOVWF __pcstackBANK0
	MOVLW 0x1
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x2
	MOVWF number
	MOVF number, W
	MOVLB 0x0
	MOVWF status_reg
	MOVLW 0x1
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x2
	MOVLW 0x1
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x2
	MOVWF number
	MOVF number, W
	MOVLB 0x0
	MOVWF al
	MOVLW 0x0
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0x2
	MOVWF number
	MOVF number, W
	MOVLB 0x0
	MOVWF x
	MOVLP 0xD
	FCALL I2C_Stop
	MOVLP 0x2
	MOVLB 0x0
	MOVF alarm1_minute, W
	MOVLP 0xD
	FCALL bcd_to_decimal
	MOVLP 0x2
	MOVWF number
	MOVF number, W
	MOVLB 0x0
	MOVWF alarm1_minute
	MOVF alarm1_hour, W
	MOVLP 0xD
	FCALL bcd_to_decimal
	MOVLP 0x2
	MOVWF number
	MOVF number, W
	MOVLB 0x0
	MOVWF alarm1_hour
	MOVF alarm2_minute, W
	MOVLP 0xD
	FCALL bcd_to_decimal
	MOVLP 0x2
	MOVWF number
	MOVF number, W
	MOVLB 0x0
	MOVWF alarm2_minute
	MOVF alarm2_hour, W
	MOVLP 0xD
	FCALL bcd_to_decimal
	MOVLP 0x2
	MOVWF number
	MOVF number, W
	MOVLB 0x0
	MOVWF alarm2_hour
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVF alarm1_minute, W
	MOVWF number
	CLRF 0x7A
	MOVF number, W
	MOVWF LCD_Str
	MOVF 0x7A, W
	MOVWF LCD_Char
	MOVLP 0xF
	FCALL __awmod
	MOVLP 0x2
	MOVF __pcstackCOMMON, W
	ADDLW 0x30
	MOVWF 0x7B
	MOVF 0x7B, W
	MOVLB 0x0
	MOVWF 0x28
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVF alarm1_minute, W
	MOVWF number
	CLRF 0x7A
	MOVF number, W
	MOVWF LCD_Str
	MOVF 0x7A, W
	MOVWF LCD_Char
	MOVLP 0x7
	FCALL __awdiv
	MOVLP 0x2
	MOVF __pcstackCOMMON, W
	ADDLW 0x30
	MOVWF 0x7B
	MOVF 0x7B, W
	MOVLB 0x0
	MOVWF 0x27
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVF alarm1_hour, W
	MOVWF number
	CLRF 0x7A
	MOVF number, W
	MOVWF LCD_Str
	MOVF 0x7A, W
	MOVWF LCD_Char
	MOVLP 0xF
	FCALL __awmod
	MOVLP 0x2
	MOVF __pcstackCOMMON, W
	ADDLW 0x30
	MOVWF 0x7B
	MOVF 0x7B, W
	MOVLB 0x0
	MOVWF 0x25
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVF alarm1_hour, W
	MOVWF number
	CLRF 0x7A
	MOVF number, W
	MOVWF LCD_Str
	MOVF 0x7A, W
	MOVWF LCD_Char
	MOVLP 0x7
	FCALL __awdiv
	MOVLP 0x2
	MOVF __pcstackCOMMON, W
	ADDLW 0x30
	MOVWF 0x7B
	MOVF 0x7B, W
	MOVLB 0x0
	MOVWF 0x24
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVF alarm2_minute, W
	MOVWF number
	CLRF 0x7A
	MOVF number, W
	MOVWF LCD_Str
	MOVF 0x7A, W
	MOVWF LCD_Char
	MOVLP 0xF
	FCALL __awmod
	MOVLP 0x2
	MOVF __pcstackCOMMON, W
	ADDLW 0x30
	MOVWF 0x7B
	MOVF 0x7B, W
	MOVLB 0x1
	MOVWF 0x28
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVLB 0x0
	MOVF alarm2_minute, W
	MOVWF number
	CLRF 0x7A
	MOVF number, W
	MOVWF LCD_Str
	MOVF 0x7A, W
	MOVWF LCD_Char
	MOVLP 0x7
	FCALL __awdiv
	MOVLP 0x2
	MOVF __pcstackCOMMON, W
	ADDLW 0x30
	MOVWF 0x7B
	MOVF 0x7B, W
	MOVLB 0x1
	MOVWF 0x27
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVLB 0x0
	MOVF alarm2_hour, W
	MOVWF number
	CLRF 0x7A
	MOVF number, W
	MOVWF LCD_Str
	MOVF 0x7A, W
	MOVWF LCD_Char
	MOVLP 0xF
	FCALL __awmod
	MOVLP 0x2
	MOVF __pcstackCOMMON, W
	ADDLW 0x30
	MOVWF 0x7B
	MOVF 0x7B, W
	MOVLB 0x1
	MOVWF 0x25
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVLB 0x0
	MOVF alarm2_hour, W
	MOVWF number
	CLRF 0x7A
	MOVF number, W
	MOVWF LCD_Str
	MOVF 0x7A, W
	MOVWF LCD_Char
	MOVLP 0x7
	FCALL __awdiv
	MOVLP 0x2
	MOVF __pcstackCOMMON, W
	ADDLW 0x30
	MOVWF 0x7B
	MOVF 0x7B, W
	MOVLB 0x1
	MOVWF 0x24
	MOVLB 0x0
	MOVF __pcstackBANK0, W 
	ANDLW 0x1
	MOVWF number
	MOVF number, W
	MOVWF alarm1_status
	LSRF __pcstackBANK0, W 
	ANDLW 0x1
	MOVWF number
	MOVF number, W
	MOVWF alarm2_status
	BTFSS al, 0x7
	GOTO A3C5
	MOVF al, W
	MOVWF number
	MOVF number, W
	MOVWF __pcstackCOMMON
	MOVLW 0xFF
	MOVLP 0xD
	FCALL __bmul
	MOVLP 0x2
	MOVWF 0x7A
	MOVF 0x7A, W
	MOVLB 0x0
	MOVWF al
	MOVLW 0x2D
	GOTO A3C6
A3C5:	MOVLW 0x20
A3C6:	MOVWF number
	MOVF number, W
	MOVWF 0x2F
	SWAPF x, F
	RRF x, F
	RRF x, F
	MOVLW 0x3
	ANDWF x, F
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVF al, W
	MOVWF LCD_Str
	CLRF LCD_Char
	BTFSC LCD_Str, 0x7
	DECF LCD_Char, F
	MOVLP 0xF
	FCALL __awmod
	MOVLP 0x2
	MOVF __pcstackCOMMON, W
	ADDLW 0x30
	MOVWF number
	MOVF number, W
	MOVLB 0x0
	MOVWF 0x31
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVF al, W
	MOVWF LCD_Str
	CLRF LCD_Char
	BTFSC LCD_Str, 0x7
	DECF LCD_Char, F
	MOVLP 0x7
	FCALL __awdiv
	MOVLP 0x2
	MOVF __pcstackCOMMON, W
	ADDLW 0x30
	MOVWF number
	MOVF number, W
	MOVLB 0x0
	MOVWF 0x30
	MOVF x, W
	BTFSC STATUS, 0x2
	GOTO A3F9
	MOVLW 0x2
	XORWF x, W
	BTFSS STATUS, 0x2
	GOTO A406
A3F9:	MOVLW 0x30
	MOVWF number
	MOVF number, W
	MOVWF 0x34
	MOVF x, W
	BTFSS STATUS, 0x2
	GOTO A402
	MOVLW 0x30
	GOTO A403
A402:	MOVLW 0x35
A403:	MOVWF number
	MOVF number, W
	MOVWF 0x33
A406:	DECF x, W
	BTFSC STATUS, 0x2
	GOTO A40D
	MOVLW 0x3
	XORWF x, W
	BTFSS STATUS, 0x2
	GOTO A41A
A40D:	MOVLW 0x35
	MOVWF number
	MOVF number, W
	MOVWF 0x34
	DECF x, W
	BTFSS STATUS, 0x2
	GOTO A416
	MOVLW 0x32
	GOTO A417
A416:	MOVLW 0x37
A417:	MOVWF number
	MOVF number, W
	MOVWF 0x33
A41A:	MOVLW 0xDF
	MOVWF number
	MOVF number, W
	MOVWF 0x35
	CLRF row
	INCF row, F
	MOVLW 0xB
	MOVLP 0xD
	FCALL LCD_Goto
	MOVLP 0x2
	MOVLW 0x2D
	MOVWF LCD_Str
	MOVLW 0x0
	MOVWF LCD_Char
	MOVLP 0xE
	FCALL LCD_Print
	MOVLP 0x2
	MOVLW 0x3
	MOVWF number
	MOVF number, W
	MOVWF row
	MOVLW 0x1
	MOVLP 0xD
	FCALL LCD_Goto
	MOVLP 0x2
	MOVLW 0x20
	MOVWF LCD_Str
	MOVLW 0x0
	MOVWF LCD_Char
	MOVLP 0xE
	FCALL LCD_Print
	MOVLP 0x2
	MOVLB 0x0
	MOVF alarm1_status, W
	BTFSC STATUS, 0x2
	GOTO A44A
	MOVLW 0x3
	MOVWF number
	MOVF number, W
	MOVWF row
	MOVLW 0x12
	MOVLP 0xD
	FCALL LCD_Goto
	MOVLP 0x2
	MOVLW 0x4
	MOVWF LCD_Str
	MOVLW 0x90
	GOTO A455
A44A:	MOVLW 0x3
	MOVWF number
	MOVF number, W
	MOVWF row
	MOVLW 0x12
	MOVLP 0xD
	FCALL LCD_Goto
	MOVLP 0x2
	MOVLW 0x8
	MOVWF LCD_Str
	MOVLW 0x90
A455:	MOVWF LCD_Char
	MOVLP 0xE
	FCALL LCD_Print
	MOVLP 0x2
	MOVLW 0x4
	MOVWF number
	MOVF number, W
	MOVWF row
	MOVLW 0x1
	MOVLP 0xD
	FCALL LCD_Goto
	MOVLP 0x2
	MOVLW 0xA0
	MOVWF LCD_Str
	MOVLW 0x0
	MOVWF LCD_Char
	MOVLP 0xE
	FCALL LCD_Print
	MOVLP 0x2
	MOVLB 0x0
	MOVF alarm2_status, W
	BTFSC STATUS, 0x2
	GOTO A47B
	MOVLW 0x4
	MOVWF number
	MOVF number, W
	MOVWF row
	MOVLW 0x12
	MOVLP 0xD
	FCALL LCD_Goto
	MOVLP 0x2
	MOVLW 0x4
	MOVWF LCD_Str
	MOVLW 0x90
	MOVWF LCD_Char
	MOVLP 0xE
	FCALL LCD_Print
	RETURN
A47B:	MOVLW 0x4
	MOVWF number
	MOVF number, W
	MOVWF row
	MOVLW 0x12
	MOVLP 0xD
	FCALL LCD_Goto
	MOVLP 0x2
	MOVLW 0x8
	MOVWF LCD_Str
	MOVLW 0x90
	MOVWF LCD_Char
	MOVLP 0xE
	FCALL LCD_Print
	RETURN
RTC_display:	MOVLB 0x0
	MOVF second, W
	MOVLP 0xD
	FCALL bcd_to_decimal
	MOVLP 0x4
	MOVWF number
	MOVF number, W
	MOVLB 0x0
	MOVWF second
	MOVF minute, W
	MOVLP 0xD
	FCALL bcd_to_decimal
	MOVLP 0x4
	MOVWF number
	MOVF number, W
	MOVLB 0x0
	MOVWF minute
	MOVF hour, W
	MOVLP 0xD
	FCALL bcd_to_decimal
	MOVLP 0x4
	MOVWF number
	MOVF number, W
	MOVLB 0x0
	MOVWF hour
	MOVF m_day, W
	MOVLP 0xD
	FCALL bcd_to_decimal
	MOVLP 0x4
	MOVWF number
	MOVF number, W
	MOVLB 0x0
	MOVWF m_day
	MOVF month, W
	MOVLP 0xD
	FCALL bcd_to_decimal
	MOVLP 0x4
	MOVWF number
	MOVF number, W
	MOVLB 0x0
	MOVWF month
	MOVF year, W
	MOVLP 0xD
	FCALL bcd_to_decimal
	MOVLP 0x4
	MOVWF number
	MOVF number, W
	MOVLB 0x0
	MOVWF year
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVF second, W
	MOVWF number
	CLRF 0x7A
	MOVF number, W
	MOVWF LCD_Str
	MOVF 0x7A, W
	MOVWF LCD_Char
	MOVLP 0xF
	FCALL __awmod
	MOVLP 0x4
	MOVF __pcstackCOMMON, W
	ADDLW 0x30
	MOVWF 0x7B
	MOVF 0x7B, W
	MOVLB 0x0
	MOVWF 0x4A
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVF second, W
	MOVWF number
	CLRF 0x7A
	MOVF number, W
	MOVWF LCD_Str
	MOVF 0x7A, W
	MOVWF LCD_Char
	MOVLP 0x7
	FCALL __awdiv
	MOVLP 0x4
	MOVF __pcstackCOMMON, W
	ADDLW 0x30
	MOVWF 0x7B
	MOVF 0x7B, W
	MOVLB 0x0
	MOVWF 0x49
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVF minute, W
	MOVWF number
	CLRF 0x7A
	MOVF number, W
	MOVWF LCD_Str
	MOVF 0x7A, W
	MOVWF LCD_Char
	MOVLP 0xF
	FCALL __awmod
	MOVLP 0x4
	MOVF __pcstackCOMMON, W
	ADDLW 0x30
	MOVWF 0x7B
	MOVF 0x7B, W
	MOVLB 0x0
	MOVWF 0x47
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVF minute, W
	MOVWF number
	CLRF 0x7A
	MOVF number, W
	MOVWF LCD_Str
	MOVF 0x7A, W
	MOVWF LCD_Char
	MOVLP 0x7
	FCALL __awdiv
	MOVLP 0x4
	MOVF __pcstackCOMMON, W
	ADDLW 0x30
	MOVWF 0x7B
	MOVF 0x7B, W
	MOVLB 0x0
	MOVWF 0x46
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVF hour, W
	MOVWF number
	CLRF 0x7A
	MOVF number, W
	MOVWF LCD_Str
	MOVF 0x7A, W
	MOVWF LCD_Char
	MOVLP 0xF
	FCALL __awmod
	MOVLP 0x4
	MOVF __pcstackCOMMON, W
	ADDLW 0x30
	MOVWF 0x7B
	MOVF 0x7B, W
	MOVLB 0x0
	MOVWF 0x44
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVF hour, W
	MOVWF number
	CLRF 0x7A
	MOVF number, W
	MOVWF LCD_Str
	MOVF 0x7A, W
	MOVWF LCD_Char
	MOVLP 0x7
	FCALL __awdiv
	MOVLP 0x4
	MOVF __pcstackCOMMON, W
	ADDLW 0x30
	MOVWF 0x7B
	MOVF 0x7B, W
	MOVLB 0x0
	MOVWF Time
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVF year, W
	MOVWF number
	CLRF 0x7A
	MOVF number, W
	MOVWF LCD_Str
	MOVF 0x7A, W
	MOVWF LCD_Char
	MOVLP 0xF
	FCALL __awmod
	MOVLP 0x4
	MOVF __pcstackCOMMON, W
	ADDLW 0x30
	MOVWF 0x7B
	MOVF 0x7B, W
	MOVLB 0x0
	MOVWF 0x41
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVF year, W
	MOVWF number
	CLRF 0x7A
	MOVF number, W
	MOVWF LCD_Str
	MOVF 0x7A, W
	MOVWF LCD_Char
	MOVLP 0x7
	FCALL __awdiv
	MOVLP 0x4
	MOVF __pcstackCOMMON, W
	ADDLW 0x30
	MOVWF 0x7B
	MOVF 0x7B, W
	MOVLB 0x0
	MOVWF 0x40
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVF month, W
	MOVWF number
	CLRF 0x7A
	MOVF number, W
	MOVWF LCD_Str
	MOVF 0x7A, W
	MOVWF LCD_Char
	MOVLP 0xF
	FCALL __awmod
	MOVLP 0x4
	MOVF __pcstackCOMMON, W
	ADDLW 0x30
	MOVWF 0x7B
	MOVF 0x7B, W
	MOVLB 0x0
	MOVWF 0x3C
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVF month, W
	MOVWF number
	CLRF 0x7A
	MOVF number, W
	MOVWF LCD_Str
	MOVF 0x7A, W
	MOVWF LCD_Char
	MOVLP 0x7
	FCALL __awdiv
	MOVLP 0x4
	MOVF __pcstackCOMMON, W
	ADDLW 0x30
	MOVWF 0x7B
	MOVF 0x7B, W
	MOVLB 0x0
	MOVWF 0x3B
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVF m_day, W
	MOVWF number
	CLRF 0x7A
	MOVF number, W
	MOVWF LCD_Str
	MOVF 0x7A, W
	MOVWF LCD_Char
	MOVLP 0xF
	FCALL __awmod
	MOVLP 0x4
	MOVF __pcstackCOMMON, W
	ADDLW 0x30
	MOVWF 0x7B
	MOVF 0x7B, W
	MOVLB 0x0
	MOVWF 0x39
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVF m_day, W
	MOVWF number
	CLRF 0x7A
	MOVF number, W
	MOVWF LCD_Str
	MOVF 0x7A, W
	MOVWF LCD_Char
	MOVLP 0x7
	FCALL __awdiv
	MOVLP 0x4
	MOVF __pcstackCOMMON, W
	ADDLW 0x30
	MOVWF 0x7B
	MOVF 0x7B, W
	MOVLB 0x0
	MOVWF Date
	CLRF row
	INCF row, F
	MOVLW 0x1
	MOVLP 0xD
	FCALL LCD_Goto
	MOVLP 0x4
	MOVLW 0x43
	MOVWF LCD_Str
	MOVLW 0x0
	MOVWF LCD_Char
	MOVLP 0xE
	FCALL LCD_Print
	MOVLP 0x4
	MOVLW 0x2
	MOVWF number
	MOVF number, W
	MOVWF row
	MOVLW 0x5
	MOVLP 0xD
	FCALL LCD_Goto
	MOVLP 0x4
	MOVLW 0x38
	MOVWF LCD_Str
	MOVLW 0x0
	MOVWF LCD_Char
	MOVLP 0xE
	FCALL LCD_Print
	MOVLP 0x4
	MOVLP 0xF
	FCALL w_day_display
	RETURN
edit:	MOVLB 0x0
	MOVWF x
A5CC:	MOVLW 0x1
	MOVLP 0xE
	FCALL debounce
	MOVLP 0x5
	BTFSC STATUS, 0x0
	GOTO 0x5CC
	MOVLW 0x3
	MOVLP 0xE
	FCALL debounce
	MOVLP 0x5
	BTFSS STATUS, 0x0
	GOTO 0x660
	GOTO 0x5CC
A5D9:	MOVLW 0x1
	MOVWF 0x7C
	MOVF 0x7C, W
	ADDWF al, F
	MOVF i, W
	BTFSC STATUS, 0x2
	GOTO 0x5E4
	MOVLW 0x5
	XORWF i, W
	BTFSS STATUS, 0x2
	GOTO 0x5E8
A5E4:	MOVLW 0x18
	SUBWF al, W
	BTFSC STATUS, 0x0
	CLRF al
A5E8:	DECF i, W
	BTFSC STATUS, 0x2
	GOTO 0x5EF
	MOVLW 0x6
	XORWF i, W
	BTFSS STATUS, 0x2
	GOTO 0x5F3
A5EF:	MOVLW 0x3C
	SUBWF al, W
	BTFSC STATUS, 0x0
	CLRF al
A5F3:	MOVLW 0x2
	XORWF i, W
	BTFSS STATUS, 0x2
	GOTO 0x5FD
	MOVLW 0x20
	SUBWF al, W
	BTFSS STATUS, 0x0
	GOTO 0x5FD
	CLRF al
	INCF al, F
A5FD:	MOVLW 0x3
	XORWF i, W
	BTFSS STATUS, 0x2
	GOTO 0x607
	MOVLW 0xD
	SUBWF al, W
	BTFSS STATUS, 0x0
	GOTO 0x607
	CLRF al
	INCF al, F
A607:	MOVLW 0x4
	XORWF i, W
	BTFSS STATUS, 0x2
	GOTO 0x610
	MOVLW 0x64
	SUBWF al, W
	BTFSS STATUS, 0x0
	GOTO 0x610
	CLRF al
A610:	MOVLW 0x7
	XORWF i, W
	BTFSS STATUS, 0x2
	GOTO 0x619
	MOVLW 0x2
	SUBWF al, W
	BTFSS STATUS, 0x0
	GOTO 0x619
	CLRF al
A619:	MOVF __pcstackBANK0, W 
	MOVWF 0x7C
	MOVF 0x7C, W
	MOVWF row
	MOVF x, W
	MOVLP 0xD
	FCALL LCD_Goto
	MOVLP 0x5
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVLB 0x0
	MOVF al, W
	MOVWF 0x7C
	CLRF 0x7D
	MOVF 0x7C, W
	MOVWF LCD_Str
	MOVF 0x7D, W
	MOVWF LCD_Char
	MOVLP 0x7
	FCALL __awdiv
	MOVLP 0x5
	MOVF __pcstackCOMMON, W
	ADDLW 0x30
	MOVLP 0xD
	FCALL LCD_PutC
	MOVLP 0x5
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVLB 0x0
	MOVF al, W
	MOVWF 0x7C
	CLRF 0x7D
	MOVF 0x7C, W
	MOVWF LCD_Str
	MOVF 0x7D, W
	MOVWF LCD_Char
	MOVLP 0xF
	FCALL __awmod
	MOVLP 0x5
	MOVF __pcstackCOMMON, W
	ADDLW 0x30
	MOVLP 0xD
	FCALL LCD_PutC
	MOVLP 0x5
	MOVLW 0x5
	MOVLB 0x0
	SUBWF i, W
	BTFSS STATUS, 0x0
	GOTO 0x654
	MOVLP 0xF
	FCALL RTC_read
	MOVLP 0x5
	MOVLP 0x4
	CALL RTC_display
	MOVLP 0x5
A654:	MOVLW 0x3
	MOVWF 0x7D
	MOVLW 0x8
	MOVWF 0x7C
	MOVLW 0x77
A659:	DECFSZ WREG, F
	GOTO 0x659
	DECFSZ 0x7C, F
	GOTO 0x659
	DECFSZ 0x7D, F
	GOTO 0x659
	NOP
A660:	MOVLB 0x0
	BTFSS PORTB, 0x2
	GOTO 0x5D9
	MOVF __pcstackBANK0, W 
	MOVWF 0x7C
	MOVF 0x7C, W
	MOVWF row
	MOVF x, W
	MOVLP 0xD
	FCALL LCD_Goto
	MOVLP 0x5
	MOVLW 0x1
	MOVWF LCD_Str
	MOVLW 0x90
	MOVWF LCD_Char
	MOVLP 0xE
	FCALL LCD_Print
	MOVLP 0x5
	MOVLP 0xD
	FCALL blink
	MOVLP 0x5
	MOVLB 0x0
	MOVF __pcstackBANK0, W 
	MOVWF 0x7C
	MOVF 0x7C, W
	MOVWF row
	MOVF x, W
	MOVLP 0xD
	FCALL LCD_Goto
	MOVLP 0x5
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVLB 0x0
	MOVF al, W
	MOVWF 0x7C
	CLRF 0x7D
	MOVF 0x7C, W
	MOVWF LCD_Str
	MOVF 0x7D, W
	MOVWF LCD_Char
	MOVLP 0x7
	FCALL __awdiv
	MOVLP 0x5
	MOVF __pcstackCOMMON, W
	ADDLW 0x30
	MOVLP 0xD
	FCALL LCD_PutC
	MOVLP 0x5
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVLB 0x0
	MOVF al, W
	MOVWF 0x7C
	CLRF 0x7D
	MOVF 0x7C, W
	MOVWF LCD_Str
	MOVF 0x7D, W
	MOVWF LCD_Char
	MOVLP 0xF
	FCALL __awmod
	MOVLP 0x5
	MOVF __pcstackCOMMON, W
	ADDLW 0x30
	MOVLP 0xD
	FCALL LCD_PutC
	MOVLP 0x5
	MOVLP 0xD
	FCALL blink
	MOVLP 0x5
	MOVLW 0x5
	MOVLB 0x0
	SUBWF i, W
	BTFSS STATUS, 0x0
	GOTO 0x6B4
	MOVLP 0xF
	FCALL RTC_read
	MOVLP 0x5
	MOVLP 0x4
	CALL RTC_display
	MOVLP 0x5
A6B4:	MOVLB 0x0
	BTFSC PORTB, 0x1
	GOTO 0x6BB
	MOVLW 0x5
	SUBWF i, W
	BTFSS STATUS, 0x0
	GOTO 0x6C1
A6BB:	BTFSC PORTB, 0x3
	GOTO 0x660
	MOVLW 0x5
	SUBWF i, W
	BTFSS STATUS, 0x0
	GOTO 0x660
A6C1:	MOVLW 0x1
	MOVWF 0x7C
	MOVF 0x7C, W
	ADDWF i, F
	MOVF al, W
	RETURN
on_off:	MOVLB 0x0
	MOVWF x
A6C9:	MOVLW 0x3
	MOVLP 0xE
	FCALL debounce
	MOVLP 0x6
	BTFSS STATUS, 0x0
	GOTO 0x6FD
	GOTO 0x6C9
A6D0:	MOVF al, W
	BTFSS STATUS, 0x2
	GOTO 0x6D5
	MOVLW 0x1
	GOTO 0x6D6
A6D5:	MOVLW 0x0
A6D6:	ANDLW 0x1
	MOVWF 0x7C
	MOVF 0x7C, W
	MOVWF al
	MOVF __pcstackBANK0, W 
	MOVWF 0x7C
	MOVF 0x7C, W
	MOVWF row
	MOVF x, W
	MOVLP 0xD
	FCALL LCD_Goto
	MOVLP 0x6
	MOVLB 0x0
	DECF al, W
	BTFSS STATUS, 0x2
	GOTO 0x6EA
	MOVLW 0x4
	MOVWF LCD_Str
	MOVLW 0x90
	GOTO 0x6ED
A6EA:	MOVLW 0x8
	MOVWF LCD_Str
	MOVLW 0x90
A6ED:	MOVWF LCD_Char
	MOVLP 0xE
	FCALL LCD_Print
	MOVLP 0x6
	MOVLW 0x3
	MOVWF 0x7D
	MOVLW 0x8
	MOVWF 0x7C
	MOVLW 0x77
A6F6:	DECFSZ WREG, F
	GOTO 0x6F6
	DECFSZ 0x7C, F
	GOTO 0x6F6
	DECFSZ 0x7D, F
	GOTO 0x6F6
	NOP
A6FD:	MOVLB 0x0
	BTFSS PORTB, 0x2
	GOTO 0x6D0
	MOVF __pcstackBANK0, W 
	MOVWF 0x7C
	MOVF 0x7C, W
	MOVWF row
	MOVF x, W
	MOVLP 0xD
	FCALL LCD_Goto
	MOVLP 0x6
	MOVLW 0x0
	MOVWF LCD_Str
	MOVLW 0x90
	MOVWF LCD_Char
	MOVLP 0xE
	FCALL LCD_Print
	MOVLP 0x6
	MOVLP 0xD
	FCALL blink
	MOVLP 0x6
	MOVLB 0x0
	MOVF __pcstackBANK0, W 
	MOVWF 0x7C
	MOVF 0x7C, W
	MOVWF row
	MOVF x, W
	MOVLP 0xD
	FCALL LCD_Goto
	MOVLP 0x6
	MOVLB 0x0
	DECF al, W
	BTFSS STATUS, 0x2
	GOTO 0x723
	MOVLW 0x4
	MOVWF LCD_Str
	MOVLW 0x90
	GOTO 0x726
A723:	MOVLW 0x8
	MOVWF LCD_Str
	MOVLW 0x90
A726:	MOVWF LCD_Char
	MOVLP 0xE
	FCALL LCD_Print
	MOVLP 0x6
	MOVLP 0xD
	FCALL blink
	MOVLP 0x6
	MOVLP 0xF
	FCALL RTC_read
	MOVLP 0x6
	MOVLP 0x4
	CALL RTC_display
	MOVLP 0x6
	MOVLB 0x0
	BTFSC PORTB, 0x3
	GOTO 0x6FD
	MOVLW 0x3
	MOVLP 0xE
	FCALL debounce
	MOVLP 0x6
	BTFSS STATUS, 0x0
	GOTO 0x6FD
	MOVLB 0x0
	MOVF al, W
	RETURN
LCD_Begin: 	MOVLB 0x0
	BCF PORTD, 0x0
	BCF PORTD, 0x0
	BCF PORTD, 0x1
	BCF PORTD, 0x2
	BCF PORTD, 0x3
	BCF PORTD, 0x4
	BCF PORTD, 0x5
	BCF TRISD, 0x0
	BCF TRISD, 0x1
	BCF TRISD, 0x2
	BCF TRISD, 0x3
	BCF TRISD, 0x4
	BCF TRISD, 0x5
	MOVLW 0x68
	MOVWF row
	MOVLW 0xE4
A750:	DECFSZ WREG, F
	GOTO 0x750
	DECFSZ row, F
	GOTO 0x750
;	BRA 0x755
	MOVLW 0x3
	MOVLP 0xD
	FCALL LCD_Cmd
	MOVLP 0x7
	MOVLW 0xD
	MOVWF row
	MOVLW 0xFC
A75C:	DECFSZ WREG, F
	GOTO 0x75C
	DECFSZ row, F
	GOTO 0x75C
	MOVLW 0x3
	MOVLP 0xD
	FCALL LCD_Cmd
	MOVLP 0x7
	MOVLW 0xD
	MOVWF row
	MOVLW 0xFC
A767:	DECFSZ WREG, F
	GOTO 0x767
	DECFSZ row, F
	GOTO 0x767
	MOVLW 0x3
	MOVLP 0xD
	FCALL LCD_Cmd
	MOVLP 0x7
	MOVLW 0xD
	MOVWF row
	MOVLW 0xFC
A772:	DECFSZ WREG, F
	GOTO 0x772
	DECFSZ row, F
	GOTO 0x772
	MOVLW 0x2
	MOVLP 0xD
	FCALL LCD_Cmd
	MOVLP 0x7
	MOVLW 0xD
	MOVWF row
	MOVLW 0xFC
A77D:	DECFSZ WREG, F
	GOTO 0x77D
	DECFSZ row, F
	GOTO 0x77D
	MOVLW 0x28
	MOVLP 0xD
	FCALL LCD_Cmd
	MOVLP 0x7
	MOVLW 0x82
	MOVWF row
	MOVLW 0xDE
A788:	DECFSZ WREG, F
	GOTO 0x788
	DECFSZ row, F
	GOTO 0x788
	MOVLW 0xC
	MOVLP 0xD
	FCALL LCD_Cmd
	MOVLP 0x7
	MOVLW 0x82
	MOVWF row
	MOVLW 0xDE
A793:	DECFSZ WREG, F
	GOTO 0x793
	DECFSZ row, F
	GOTO 0x793
	MOVLW 0x1
	MOVLP 0xD
	FCALL LCD_Cmd
	MOVLP 0x7
	MOVLW 0x82
	MOVWF row
	MOVLW 0xDE
A79E:	DECFSZ WREG, F
	GOTO 0x79E
	DECFSZ row, F
	GOTO 0x79E
	MOVLW 0x6
	MOVLP 0xD
	FCALL LCD_Cmd
	MOVLP 0x7
	MOVLW 0x82
	MOVWF row
	MOVLW 0xDE
A7A9:	DECFSZ WREG, F
	GOTO 0x7A9
	DECFSZ row, F
	GOTO 0x7A9
	RETURN
__awdiv:	CLRF sign
	BTFSS n, 0x7
	GOTO 0x7B8
	COMF __pcstackCOMMON, F
	COMF n, F
	INCF __pcstackCOMMON, F
	BTFSC STATUS, 0x2
	INCF n, F
	CLRF sign
	INCF sign, F
A7B8:	BTFSS LCD_Char, 0x7
	GOTO 0x7C3
	COMF LCD_Str, F
	COMF LCD_Char, F
	INCF LCD_Str, F
	BTFSC STATUS, 0x2
	INCF LCD_Char, F
	MOVLW 0x1
	MOVWF row
	MOVF row, W
	XORWF sign, F
A7C3:	CLRF i
	CLRF 0x78
	MOVF __pcstackCOMMON, W
	IORWF n, W
	BTFSC STATUS, 0x2
	GOTO 0x7F2
	CLRF col
	INCF col, F
A7CB:	BTFSC n, 0x7
	GOTO 0x7D7
	MOVLW 0x1
A7CE:	LSLF __pcstackCOMMON, F
	RLF n, F
	DECFSZ WREG, F
	GOTO 0x7CE
	MOVLW 0x1
	MOVWF row
	MOVF row, W
	ADDWF col, F
	GOTO 0x7CB
A7D7:	MOVLW 0x1
A7D8:	LSLF i, F
	RLF 0x78, F
	DECFSZ WREG, F
	GOTO 0x7D8
	MOVF n, W
	SUBWF LCD_Char, W
	BTFSS STATUS, 0x2
	GOTO 0x7E2
	MOVF __pcstackCOMMON, W
	SUBWF LCD_Str, W
A7E2:	BTFSS STATUS, 0x0
	GOTO 0x7E9
	MOVF __pcstackCOMMON, W
	SUBWF LCD_Str, F
	MOVF n, W
	SUBWFB LCD_Char, F
	BSF i, 0x0
A7E9:	MOVLW 0x1
A7EA:	LSRF n, F
	RRF __pcstackCOMMON, F 
	DECFSZ WREG, F
	GOTO 0x7EA
	MOVLW 0x1
	SUBWF col, F
	BTFSS STATUS, 0x2
	GOTO 0x7D7
A7F2:	MOVF sign, W
	BTFSC STATUS, 0x2
	GOTO 0x7FA
	COMF i, F
	COMF 0x78, F
	INCF i, F
	BTFSC STATUS, 0x2
	INCF 0x78, F
A7FA:	MOVF 0x78, W
	MOVWF n
	MOVF i, W
	MOVWF __pcstackCOMMON
	RETURN
AD1A:	CLRWDT
AD1B:	CLRF INDF0
	ADDFSR 0, 1
	DECFSZ WREG, F
	LJMP AD1B
	RETLW 0x0
AD20:	MOVWF 0x7E
AD21:	MOVIW FSR0++
	MOVWI FSR1++
	DECFSZ 0x7E, F
	LJMP AD21
	RETLW 0x0
I2C_Init:	MOVLW 0x28
	MOVLB 0x3
	MOVWF PORTE
	MOVLW 0x4F
	MOVWF PORTB
	CLRF PORTD
	RETURN
I2C_Repeated_Start:	MOVLB 0x3
	BTFSC PORTD, 0x2
	LJMP I2C_Repeated_Start
	MOVF TRISA, W
	ANDLW 0x1F
	BTFSS STATUS, 0x2
	LJMP I2C_Repeated_Start
	BSF TRISA, 0x1
	RETURN
I2C_Start:	MOVLB 0x3
	BTFSC PORTD, 0x2
	LJMP I2C_Start
	MOVF TRISA, W
	ANDLW 0x1F
	BTFSS STATUS, 0x2
	LJMP I2C_Start
	BSF TRISA, 0x0
	RETURN
I2C_Stop:	MOVLB 0x3
	BTFSC PORTD, 0x2
	LJMP I2C_Stop
	MOVF TRISA, W
	ANDLW 0x1F
	BTFSS STATUS, 0x2
	LJMP I2C_Stop
	BSF TRISA, 0x2
	RETURN
I2C_Write:	MOVWF __pcstackCOMMON
AD49:	MOVLB 0x3
	BTFSC PORTD, 0x2
	LJMP I2C_Write
	MOVF TRISA, W
	ANDLW 0x1F
	BTFSS STATUS, 0x2
	LJMP I2C_Write
	MOVF __pcstackCOMMON, W
	MOVWF PORTA
	RETURN

__bmul:	MOVWF LCD_Char
	CLRF LCD_Str
AD62:	BTFSS LCD_Char, 0x0
	GOTO 0x568
	MOVF __pcstackCOMMON, W
	MOVWF n
	MOVF n, W
	ADDWF LCD_Str, F
AD68:	BCF STATUS, 0x0
	RLF __pcstackCOMMON, F 
	BCF STATUS, 0x0
	RRF LCD_Char, F
	MOVF LCD_Char, W
	BTFSS STATUS, 0x2
	GOTO 0x562
	MOVF LCD_Str, W
	RETURN
LCD_PutC:	MOVWF LCD_Char
	MOVLB 0x0
	BSF PORTD, 0x0
	MOVF LCD_Char, W
	MOVWF LCD_Str
	MOVLW 0x4
AD77:	LSRF LCD_Str, F
	DECFSZ WREG, F
	GOTO 0x577
	MOVF LCD_Str, W
	MOVLP 0xE
	FCALL LCD_Write_Nibble
	MOVLP 0xD
	MOVF LCD_Char, W
	MOVLP 0xE
	FCALL LCD_Write_Nibble
	RETURN
bcd_to_decimal:	MOVWF i
	MOVLW 0xF
	ANDWF i, W
	MOVWF row
	MOVLW 0xA
	MOVWF col
	MOVF col, W
	MOVWF __pcstackCOMMON
	MOVF i, W
	MOVWF sign
	MOVLW 0x4
AD8D:	LSRF sign, F
	DECFSZ WREG, F
	GOTO 0x58D
	MOVF sign, W
	MOVLP 0xD
	FCALL __bmul
	ADDWF row, W
	RETURN
blink:	CLRF n
AD96:	MOVLW 0x64
	SUBWF n, W
	BTFSC STATUS, 0x0
	RETURN
	MOVLB 0x0
	BTFSC PORTB, 0x1
	GOTO 0x5A1
	MOVLW 0x5
	SUBWF i, W
	BTFSS STATUS, 0x0
	RETURN
ADA1:	BTFSS PORTB, 0x2
	RETURN
	BTFSC PORTB, 0x3
	GOTO 0x5A9
	MOVLW 0x5
	SUBWF i, W
	BTFSC STATUS, 0x0
	RETURN
ADA9:	MOVLW 0x1
	MOVWF __pcstackCOMMON
	MOVF __pcstackCOMMON, W
	ADDWF n, F
	MOVLW 0xD
	MOVWF __pcstackCOMMON
	MOVLW 0xFC
ADB0:	DECFSZ WREG, F
	GOTO 0xDB0
	DECFSZ __pcstackCOMMON, F
	GOTO 0xDB0
	GOTO 0x596
	
	
	
LCD_Cmd:; void LCD_Cmd(uint8_t Command) {	
	MOVWF LCD_Char
	MOVLB 0x0
	BCF PORTD, 0x0	;  RS = 0;
	MOVF LCD_Char, W	; LCD_Write_Nibble(Command >> 4);
	MOVWF LCD_Str
	MOVLW 0x4
ADBB:	LSRF LCD_Str, F
	DECFSZ WREG, F
	GOTO 0xDBB
	MOVF LCD_Str, W
	MOVLP 0xE
	FCALL LCD_Write_Nibble
	MOVLP 0xD
	MOVF LCD_Char, W
	MOVLP 0xE
	FCALL LCD_Write_Nibble
	MOVLP 0xD
	DECF LCD_Char, W
	BTFSC STATUS, 0x2
	GOTO 0xDCD
	MOVLW 0x2
	XORWF LCD_Char, W
	BTFSS STATUS, 0x2
	RETURN
ADCD:	MOVLW 0x6
	MOVWF LCD_Str
	MOVLW 0x30
ADD0:	DECFSZ WREG, F
	GOTO 0xDD0
	DECFSZ LCD_Str, F
	GOTO 0xDD0
;	BRA 0xDD5
	RETURN
	
;*******************************************************************************	
;            void LCD_Goto(uint8_t col, uint8_t row) {
;*******************************************************************************
	
LCD_Goto:;void LCD_Goto(uint8_t col, uint8_t row) {
	MOVWF col
	LJMP ADEC	
ADEC:	; switch (row) {
	MOVF row, W
	XORLW 0x2
	BTFSC STATUS, 0x2
	LJMP ADD8
	XORLW 0x1
	BTFSC STATUS, 0x2
	LJMP ADDD
	XORLW 0x7
	BTFSC STATUS, 0x2
	LJMP ADE2
	LJMP ADE7	
ADD8:	; case 2: LCD_Cmd(LCD_SECOND_ROW + col - 1);
	MOVF col, W
	ADDLW 0xBF
	MOVLP 0xD
	FCALL LCD_Cmd
	RETURN		; break;
	
ADDD:	; case 3:LCD_Cmd(LCD_THIRD_ROW + col - 1);
	MOVF col, W
	ADDLW 0x93
	MOVLP 0xD
	FCALL LCD_Cmd
	RETURN		; break;
	
ADE2:	; case 4:LCD_Cmd(LCD_FOURTH_ROW + col - 1);
	MOVF col, W
	ADDLW 0xD3
	MOVLP 0xD
	FCALL LCD_Cmd
	RETURN		; break;
	
ADE7:	; default: // case 1:LCD_Cmd(LCD_FIRST_ROW + col - 1);
	MOVF col, W
	ADDLW 0x7F
	MOVLP 0xD
	FCALL LCD_Cmd
	RETURN
	
I2C_Read:	MOVWF n
ADF9:	MOVLB 0x3
	BTFSC PORTD, 0x2
	LJMP I2C_Read
	MOVF TRISA, W
	ANDLW 0x1F
	BTFSS STATUS, 0x2
	LJMP I2C_Read
	BSF TRISA, 0x3
AE01:	BTFSC PORTD, 0x2
	GOTO 0x601
	MOVF TRISA, W
	ANDLW 0x1F
	BTFSS STATUS, 0x2
	GOTO 0x601
	MOVF PORTA, W
	MOVWF __pcstackCOMMON
	MOVF __pcstackCOMMON, W
	MOVWF LCD_Str
AE0B:	BTFSC PORTD, 0x2
	GOTO 0x60B
	MOVF TRISA, W
	ANDLW 0x1F
	BTFSS STATUS, 0x2
	GOTO 0x60B
	MOVF n, W
	BTFSS STATUS, 0x2
	GOTO 0x617
	MOVLB 0x3
	BSF TRISA, 0x5
	GOTO 0x619
AE17:	MOVLB 0x3
	BCF TRISA, 0x5
AE19:	BSF TRISA, 0x4
	MOVF LCD_Str, W
	RETURN
debounce:	MOVWF n
	CLRF LCD_Str
	CLRF LCD_Char
	GOTO 0x63B
AE20:	MOVLB 0x0
	BTFSC PORTB, 0x1
	GOTO 0x62B
AE23:	MOVLW 0x1
	MOVWF __pcstackCOMMON
	MOVF __pcstackCOMMON, W
	ADDWF LCD_Str, F
	GOTO 0x62B
	MOVLB 0x0
	BTFSS PORTB, 0x3
	GOTO 0x623
AE2B:	MOVLW 0x1A
	MOVWF __pcstackCOMMON
	MOVLW 0xF8
AE2E:	DECFSZ WREG, F
	GOTO 0x62E
	DECFSZ __pcstackCOMMON, F
	GOTO 0x62E
;	BRA 0xE33
	MOVLW 0x1
	MOVWF __pcstackCOMMON
	MOVF __pcstackCOMMON, W
	ADDWF LCD_Char, F
	MOVLW 0x5
	SUBWF LCD_Char, W
	BTFSC STATUS, 0x0
	GOTO 0x644
AE3B:	MOVF n, W
	XORLW 0x1
	BTFSC STATUS, 0x2
	GOTO 0x620
	XORLW 0x2
	BTFSC STATUS, 0x2
	GOTO 0x628
	GOTO 0x62B
	GOTO 0x62B
AE44:	MOVLW 0x3
	SUBWF LCD_Str, W
	RETURN

decimal_to_bcd:	MOVWF number
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVF number, W
	MOVLB 0x0
	MOVWF __pcstackBANK0
	CLRF al
	MOVF __pcstackBANK0, W 
	MOVWF LCD_Str
	MOVF al, W
	MOVWF LCD_Char
	MOVLP 0xF
	FCALL __awmod
	MOVLP 0xE
	MOVF __pcstackCOMMON, W
	MOVLB 0x0
	MOVWF x
	MOVF n, W
	MOVWF 0x5E
	MOVLW 0xA
	MOVWF __pcstackCOMMON
	MOVLW 0x0
	MOVWF n
	MOVF number, W
	MOVWF 0x5F
	CLRF 0x60
	MOVF 0x5F, W
	MOVWF LCD_Str
	MOVF 0x60, W
	MOVWF LCD_Char
	MOVLP 0x7
	FCALL __awdiv
	MOVLP 0xE
	MOVF __pcstackCOMMON, W
	MOVLB 0x0
	MOVWF 0x61
	MOVLW 0x3
AE9A:	LSLF 0x61, F
	ADDLW 0xFF
	BTFSS STATUS, 0x2
	GOTO 0x69A
	LSLF 0x61, W
	ADDWF x, W
	RETURN
LCD_Print:	CLRF i
	MOVLB 0x0
	BSF PORTD, 0x0
AEA4:	MOVF LCD_Char, W
	MOVWF col
	MOVF LCD_Str, W
	MOVWF row
	MOVF i, W
	ADDWF row, W
	MOVWF FSR0L
	MOVF col, W
	BTFSC STATUS, 0x0
	INCF col, W
	MOVWF FSR0H
	MOVIW FSR0++
	BTFSC STATUS, 0x2
	RETURN
	MOVF LCD_Char, W
	MOVWF col
	MOVF LCD_Str, W
	MOVWF row
	MOVF i, W
	ADDWF row, W
	MOVWF FSR0L
	MOVF col, W
	BTFSC STATUS, 0x0
	INCF col, W
	MOVWF FSR0H
	MOVF INDF0, W
	MOVWF sign
	MOVLW 0x4
AEC0:	LSRF sign, F
	DECFSZ WREG, F
	GOTO 0x6C0
	MOVF sign, W
	MOVLP 0xE
	FCALL LCD_Write_Nibble
	MOVLP 0xE
	MOVF LCD_Char, W
	MOVWF col
	MOVF LCD_Str, W
	MOVWF row
	MOVF i, W
	ADDWF row, W
	MOVWF FSR0L
	MOVF col, W
	BTFSC STATUS, 0x0
	INCF col, W
	MOVWF FSR0H
	MOVF INDF0, W
	MOVLP 0xE
	FCALL LCD_Write_Nibble
	MOVLP 0xE
	MOVLW 0x1
	MOVWF row
	MOVF row, W
	ADDWF i, F
	GOTO 0x6A4
LCD_Write_Nibble:	MOVWF n
	MOVLB 0x0
	BTFSS PORTD, 0x0
	GOTO 0x6E2
	MOVLB 0x0
	BSF PORTD, 0x0
	LJMP AEE4
AEE2:	MOVLB 0x0
	BCF PORTD, 0x0
AEE4:	BTFSS n, 0x0
	LJMP AEE9
	MOVLB 0x0
	BSF PORTD, 0x2
	GOTO 0x6EB
AEE9:	MOVLB 0x0
	BCF PORTD, 0x2
AEEB:	MOVF n, W
	MOVWF __pcstackCOMMON
	MOVLW 0x1
AEEE:	LSRF __pcstackCOMMON, F
	DECFSZ WREG, F
	GOTO 0x6EE
	BTFSS __pcstackCOMMON, 0x0
	GOTO 0x6F6
	MOVLB 0x0
	BSF PORTD, 0x3
	GOTO 0x6F8
AEF6:	MOVLB 0x0
	BCF PORTD, 0x3
AEF8:	MOVF n, W
	MOVWF __pcstackCOMMON
	MOVLW 0x2
AEFB:	LSRF __pcstackCOMMON, F
	DECFSZ WREG, F
	GOTO 0x6FB
	BTFSS __pcstackCOMMON, 0x0
	GOTO 0x703
	MOVLB 0x0
	BSF PORTD, 0x4
	GOTO 0x705
AF03:	MOVLB 0x0
	BCF PORTD, 0x4
AF05:	MOVF n, W
	MOVWF __pcstackCOMMON
	MOVLW 0x3
AF08:	LSRF __pcstackCOMMON, F
	DECFSZ WREG, F
	GOTO 0x708
	BTFSS __pcstackCOMMON, 0x0
	GOTO 0x710
	MOVLB 0x0
	BSF PORTD, 0x5
	GOTO 0x712
AF10:	MOVLB 0x0
	BCF PORTD, 0x5
AF12:	BCF PORTD, 0x1
;	BRA 0xF14
	MOVLB 0x0
	BSF PORTD, 0x1
;	BRA 0xF17
	MOVLB 0x0
	BCF PORTD, 0x1
	MOVLW 0x42
AF1A:	DECFSZ WREG, F
	LJMP AF1A
;	BRA 0xF1D
	RETURN
__awmod:	CLRF sign
	BTFSS LCD_Char, 0x7
	GOTO 0x728
	COMF LCD_Str, F
	COMF LCD_Char, F
	INCF LCD_Str, F
	BTFSC STATUS, 0x2
	INCF LCD_Char, F
	CLRF sign
	INCF sign, F
AF28:	BTFSS n, 0x7
	GOTO 0x72F
	COMF __pcstackCOMMON, F
	COMF n, F
	INCF __pcstackCOMMON, F
	BTFSC STATUS, 0x2
	INCF n, F
AF2F:	MOVF __pcstackCOMMON, W
	IORWF n, W
	BTFSC STATUS, 0x2
	GOTO 0x756
	CLRF col
	INCF col, F
AF35:	BTFSC n, 0x7
	GOTO 0x741
	MOVLW 0x1
AF38:	LSLF __pcstackCOMMON, F
	RLF n, F
	DECFSZ WREG, F
	GOTO 0x738
	MOVLW 0x1
	MOVWF row
	MOVF row, W
	ADDWF col, F
	GOTO 0x735
AF41:	MOVF n, W
	SUBWF LCD_Char, W
	BTFSS STATUS, 0x2
	GOTO 0x747
	MOVF __pcstackCOMMON, W
	SUBWF LCD_Str, W
AF47:	BTFSS STATUS, 0x0
	GOTO 0x74D
	MOVF __pcstackCOMMON, W
	SUBWF LCD_Str, F
	MOVF n, W
	SUBWFB LCD_Char, F
AF4D:	MOVLW 0x1
AF4E:	LSRF n, F
	RRF __pcstackCOMMON, F 
	DECFSZ WREG, F
	GOTO 0x74E
	MOVLW 0x1
	SUBWF col, F
	BTFSS STATUS, 0x2
	GOTO 0x741
AF56:	MOVF sign, W
	BTFSC STATUS, 0x2
	GOTO 0x75E
	COMF LCD_Str, F
	COMF LCD_Char, F
	INCF LCD_Str, F
	BTFSC STATUS, 0x2
	INCF LCD_Char, F
AF5E:	MOVF LCD_Char, W
	MOVWF n
	MOVF LCD_Str, W
	MOVWF __pcstackCOMMON
	RETURN
RTC_read:	MOVLP 0xD
	FCALL I2C_Start
	MOVLP 0xF
	MOVLW 0xD0
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0xF
	MOVLW 0x0
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0xF
	MOVLP 0xD
	FCALL I2C_Repeated_Start
	MOVLP 0xF
	MOVLW 0xD1
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0xF
	MOVLW 0x1
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0xF
	MOVWF LCD_Char
	MOVF LCD_Char, W
	MOVLB 0x0
	MOVWF second
	MOVLW 0x1
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0xF
	MOVWF LCD_Char
	MOVF LCD_Char, W
	MOVLB 0x0
	MOVWF minute
	MOVLW 0x1
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0xF
	MOVWF LCD_Char
	MOVF LCD_Char, W
	MOVLB 0x0
	MOVWF hour
	MOVLW 0x1
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0xF
	MOVWF LCD_Char
	MOVF LCD_Char, W
	MOVLB 0x0
	MOVWF w_day
	MOVLW 0x1
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0xF
	MOVWF LCD_Char
	MOVF LCD_Char, W
	MOVLB 0x0
	MOVWF m_day
	MOVLW 0x1
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0xF
	MOVWF LCD_Char
	MOVF LCD_Char, W
	MOVLB 0x0
	MOVWF month
	MOVLW 0x0
	MOVLP 0xD
	FCALL I2C_Write
	MOVLP 0xF
	MOVWF LCD_Char
	MOVF LCD_Char, W
	MOVLB 0x0
	MOVWF year
	MOVLP 0xD
	FCALL I2C_Stop
	RETURN
w_day_display:	MOVLW 0x2
	MOVWF 0x78
	MOVF 0x78, W
	MOVWF row
	MOVLW 0x1
	MOVLP 0xD
	FCALL LCD_Goto
	MOVLP 0xF
	GOTO 0x7EA
AFB9:	MOVLW 0x1C
	MOVWF LCD_Str
	MOVLW 0x90
	MOVWF LCD_Char
	MOVLP 0xE
	FCALL LCD_Print
	RETURN
AFC0:	MOVLW 0x18
	MOVWF LCD_Str
	MOVLW 0x90
	MOVWF LCD_Char
	MOVLP 0xE
	FCALL LCD_Print
	RETURN
AFC7:	MOVLW 0x10
	MOVWF LCD_Str
	MOVLW 0x90
	MOVWF LCD_Char
	MOVLP 0xE
	FCALL LCD_Print
	RETURN
	MOVLW 0xC
	MOVWF LCD_Str
	MOVLW 0x90
	MOVWF LCD_Char
	MOVLP 0xE
	FCALL LCD_Print
	RETURN
AFD5:	MOVLW 0x24
	MOVWF LCD_Str
	MOVLW 0x90
	MOVWF LCD_Char
	MOVLP 0xE
	FCALL LCD_Print
	RETURN
AFDC:	MOVLW 0x14
	MOVWF LCD_Str
	MOVLW 0x90
	MOVWF LCD_Char
	MOVLP 0xE
	FCALL LCD_Print
	RETURN
AFE3:	MOVLW 0x20
	MOVWF LCD_Str
	MOVLW 0x90
	MOVWF LCD_Char
	MOVLP 0xE
	FCALL LCD_Print
	RETURN
AFEA:	MOVLB 0x0
	MOVF w_day, W
	XORLW 0x1
	BTFSC STATUS, 0x2
	GOTO 0x7B9
	XORLW 0x3
	BTFSC STATUS, 0x2
	GOTO 0x7C0
	XORLW 0x1
	BTFSC STATUS, 0x2
	GOTO 0x7C7
	XORLW 0x7
	BTFSC STATUS, 0x2
	GOTO 0x7CE
	XORLW 0x1
	BTFSC STATUS, 0x2
	GOTO 0x7D5
	XORLW 0x3
	BTFSC STATUS, 0x2
	GOTO 0x7DC
	GOTO 0x7E3
	RETURN
	
	end	resetVec